<?php

/*===============================================*\
|| ############################################# ||
|| # JAKWEB.CH / Version 3.1                   # ||
|| # ----------------------------------------- # ||
|| # Copyright 2018 JAKWEB All Rights Reserved # ||
|| ############################################# ||
\*===============================================*/

if (!file_exists('../config.php')) die('[update.php] config.php not found');
require_once '../config.php';

/* NO CHANGES FROM HERE */

// Set successfully to zero
$succesfully = 0;

?>

<!DOCTYPE html>
<html lang="en">

<head>
	<title>Update HelpDesk 3</title>
	<meta charset="utf-8">
	<meta name="author" content="HelpDesk 3 (https://www.jakweb.ch)" />
	<link rel="shortcut icon" href="../favicon.ico" type="image/x-icon" />
	<link rel="stylesheet" href="../css/stylesheet.css" type="text/css" media="screen" />
</head>
<body>

<nav class="navbar navbar-inverse bg-primary bg-light">
  <a class="navbar-brand" href="https://www.jakweb.ch">Update HelpDesk 3</a>
</nav>

<div class="container mt-5">
<div class="row-fluid">
<div class="col-md-12">

<?php 

$version = $jakdb->get("settings", "value", ["varname" => "version"]);
if ($version == "3.1") { $succesfully = 1; ?>

<div class="alert alert-info">Your HelpDesk 3 is already up to date!</div>

<!-- Plugin is not installed let's display the installation script -->
<?php } else { if (isset($_POST['update']) && $_GET['step'] == 2) {

// Version 3.1
$jakdb->query("DELETE FROM ".JAKDB_PREFIX."settings WHERE `varname` = 'langdirection'");
$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."chatwidget ADD `btn_animation` VARCHAR(20) NULL AFTER `floatcsschat`");
$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."chatwidget ADD `chat_animation` VARCHAR(20) NULL AFTER `btn_animation`");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."settings (`id`, `varname`, `used_value`, `default_value`) VALUES (NULL, 'calendar_tickets', '0', '0'),
(NULL, 'calendar_chats', '0', '0'),
(NULL, 'calendar_offline', '0', '0'),
(NULL, 'calendar_purchases', '0', '0')");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."events (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `userid` int(10) unsigned NOT NULL DEFAULT '0',
  `clientid` int(10) unsigned NOT NULL DEFAULT '0',
  `color` varchar(7) DEFAULT NULL,
  `start` datetime NOT NULL,
  `end` datetime DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `content` mediumtext,
  `url` varchar(255) DEFAULT NULL,
  `status` tinyint(3) NOT NULL DEFAULT '0',
  `lastedit` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  `created` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `userid` (`userid`,`clientid`,`start`,`end`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8");

$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."bot_question ADD `widgetids` varchar(100) NOT NULL DEFAULT '0' AFTER `id`");
$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."bot_question ADD INDEX `depid_lang_widgetids` (`depid`, `lang`, `widgetids`), DROP INDEX `depid`");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."answers (`department`, `lang`, `title`, `message`, `fireup`, `msgtype`, `created`)
VALUES ('0', 'en', 'Support Rating', '<h3>How would you rate the support you received?</h3><p>Hello {cname},<br>We\'d love to hear what you think of our customer service. Please take a moment to rate the support you have received by clicking the link below.<br>How would you rate the support you received?</p><p><a href=\"{ticketurl}\">Rate your ticket here</a></p>', '15', '25', NOW())");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."ticket_rating (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `ticketid` int(10) unsigned NOT NULL DEFAULT '0',
  `clientid` int(10) unsigned NOT NULL DEFAULT '0',
  `vote` int(10) unsigned NOT NULL DEFAULT '0',
  `name` varchar(100) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `comment` text,
  `support_time` int(10) unsigned NOT NULL DEFAULT '0',
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `ticketid` (`ticketid`,`clientid`,`vote`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

// confirm
$email_body = 'URL: '.BASE_URL.'<br />Email: '.JAK_EMAIL.'<br />License: '.JAK_O_NUMBER;

// Send the email to the customer
$mail = new PHPMailer(); // defaults to using php "mail()"
$body = str_ireplace("[\]", "", $email_body);
$mail->SetFrom(JAK_EMAIL);
$mail->AddReplyTo(JAK_EMAIL);
$mail->AddAddress('lic@jakweb.ch');
$mail->Subject = 'Update - HelpDesk 3 / 3.1';
$mail->AltBody = 'HTML Format';
$mail->MsgHTML($body);
$mail->Send();

// update time so css and javascript will be loaded fresh
$jakdb->query('UPDATE '.JAKDB_PREFIX.'settings SET used_value = "'.time().'" WHERE varname = "updated"');
// update version
$jakdb->query('UPDATE '.JAKDB_PREFIX.'settings SET used_value = "3.1" WHERE varname = "version"');

$succesfully = 1;

// Now let us delete all cache files
$cacheallfiles = '../'.JAK_CACHE_DIRECTORY.'/';
$msfi = glob($cacheallfiles."*.php");
if ($msfi) foreach ($msfi as $filen) {
    if (file_exists($filen)) unlink($filen);
}

?>
<div class="alert alert-success">Database update successfully, please delete the <strong>install</strong> directory and then login into your <a href="../operator/">operator</a> panel.</div>
<?php } ?>

<?php if (!$succesfully) { ?>
<div class="alert alert-info">Please follow this steps carefully before you update the database!</div>
<ul>
	<li>Backup all your files and your database.</li>
	<li>Upload all folders and files from the new version.</li>
	<li>Be sure to have a backup from your database before you update!</li>
	<li>Do you have an up to date backup from your database? OK, hit "Update Database".</li>
</ul>

<form name="company" method="post" action="update.php?step=2" enctype="multipart/form-data">

<div class="form-actions">
<button type="submit" name="update" class="btn btn-primary pull-right">Update Database</button>
</div>

</form>
<?php } } ?>

</div>
</div>

</div>

</div><!-- #container -->
</body>
</html>