<?php

/*===============================================*\
|| ############################################# ||
|| # JAKWEB.CH / Version 3.1                   # ||
|| # ----------------------------------------- # ||
|| # Copyright 2018 JAKWEB All Rights Reserved # ||
|| ############################################# ||
\*===============================================*/

if (!file_exists('../config.php')) die('[update.php] config.php not found');
require_once '../config.php';

/* NO CHANGES FROM HERE */

// Set successfully to zero
$succesfully = 0;

?>

<!DOCTYPE html>
<html lang="en">

<head>
	<title>Update HelpDesk 3</title>
	<meta charset="utf-8">
	<meta name="author" content="HelpDesk 3 (https://www.jakweb.ch)" />
	<link rel="shortcut icon" href="../favicon.ico" type="image/x-icon" />
	<link rel="stylesheet" href="../css/stylesheet.css" type="text/css" media="screen" />
</head>
<body>

<nav class="navbar navbar-inverse bg-primary bg-light">
  <a class="navbar-brand" href="https://www.jakweb.ch">Update HelpDesk 3</a>
</nav>

<div class="container mt-5">
<div class="row-fluid">
<div class="col-md-12">

<?php 

$version = $jakdb->get("settings", "value", ["varname" => "version"]);
if ($version == "3.1") { $succesfully = 1; ?>

<div class="alert alert-info">Your HelpDesk 3 is already up to date!</div>

<!-- Plugin is not installed let's display the installation script -->
<?php } else { if (isset($_POST['update']) && $_GET['step'] == 2) {

// We move from Live Chat 3
$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."departments ADD `guesta` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1' AFTER `faq_url`");
$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."departments ADD `credits` INT UNSIGNED NOT NULL DEFAULT '0' AFTER `faq_url`");

$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."user DROP `departments`");
$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."user ADD `chat_dep` VARCHAR(100) NOT NULL DEFAULT '0' AFTER `id`, ADD `support_dep` VARCHAR(100) NOT NULL DEFAULT '0' AFTER `chat_dep`;");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."settings (`id`, `varname`, `used_value`, `default_value`) VALUES (NULL, 'recap_client', NULL, NULL), (NULL, 'recap_server', NULL, NULL), (NULL, 'billing_mode', '0', '0'), (NULL, 'billing_mode', '0', '0'),
(NULL, 'ticket_close_r', '0', '0'),
(NULL, 'ticket_inform_r', '0', '0'),
(NULL, 'ticket_guest', '0', '0'),
(NULL, 'ticket_account', '0', '0'),
(NULL, 'ticket_format', '0', '0'),
(NULL, 'ticket_limit', '0', '0'),
(NULL, 'ticket_reminder', '0', '0'),
(NULL, 'ticket_close_c', '0', '0'),
(NULL, 'ticket_reopen', '0', '0'),
(NULL, 'ticket_attach', '0', '0'),
(NULL, 'faq_a', '1', '1'),
(NULL, 'faq_home', '4', '4'),
(NULL, 'faq_footer', '3', '3'),
(NULL, 'blog_a', '1', '1'),
(NULL, 'blog_home', '3', '3'),
(NULL, 'blog_footer', '2', '2'),
(NULL, 'standard_chat_dep', '0', '0'),
(NULL, 'standard_support_dep', '0', '0'),
(NULL, 'standard_faq_dep', '0', '0'),
(NULL, 'front_template', 'standard', 'standard'),
(NULL, 'is_offline', '0', '0'),
(NULL, 'offline_cms_page', '10', '10'),
(NULL, 'stripe_publish_key', '', ''),
(NULL, 'stripe_secret_key', '', ''),
(NULL, 'paypal_email', '', ''),
(NULL, 'blogpostapprove', '', ''),
(NULL, 'standard_ticket_priority', '0', '0'),
(NULL, 'standard_ticket_option', '0', '0'),
(NULL, 'ticket_private', '0', '0'),
(NULL, 'ticket_guest_web', '0', '0'),
(NULL, 'register', '1', '1'),
(NULL, 'calendar_tickets', '0', '0'),
(NULL, 'calendar_chats', '0', '0'),
(NULL, 'calendar_offline', '0', '0'),
(NULL, 'calendar_purchases', '0', '0')");

// Add client id to different locations
$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."sessions ADD `clientid` INT(10) UNSIGNED NOT NULL DEFAULT '0' AFTER `operatorid`");
$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."sessions ADD `credits` SMALLINT UNSIGNED NOT NULL DEFAULT '0' AFTER `notes`");

$jakdb->query("ALTER TABLE ".JAKDB_PREFIX."buttonstats ADD `clientid` INT UNSIGNED NOT NULL DEFAULT '0' AFTER `opid`");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."answers (`id`, `department`, `lang`, `title`, `message`, `fireup`, `msgtype`, `created`) VALUES (NULL, 0, 'en', 'Register Email', '<p>Thank you very much for opening an account with us.<br /><br />You have used following email address: {cemail}<br />Please use following password to login into your account: {cpassword}<br /><br />You can now login on our site <a href=\"{url}\">{title}</a> and change your information, avatar and or password.</p>', 15, 14, NOW()),
(NULL, 0, 'en', 'Welcome Register Web', '<div class=\"container\">
<div class=\"row\">
<div class=\"col-lg-12\">
<h2>Thank You</h2>
<p>Your account has been registered and an email has been sent to the provided email address with your password and further informations.</p>
<p>Please also check your spam/junk folder, if you should not receive an email from us within the next 2 hours, please contact us thru following email address: {email}.</p>
<p>Kind regards<br />{title}</p>
</div>
</div>
</div>', 15, 15, NOW()),
(NULL, 0, 'en', 'Forgot Password Email', '<p>Someone (hopefully you!) has submitted a forgotten password request for your account. If you do not wish to change your password, just ignore this email and nothing will happen. However, if you did forget your password and wish to set a new one, visit the following link: {reset}</p>', 15, 16, NOW()),
(NULL, 0, 'en', 'password', '<div class=\"container\">
<div class=\"row\">
<div class=\"col-lg-12\">
<h2>Password Reset Web</h2>
<p>An email has been sent with a link to reset your password.</p>
<p>Please also check your spam/junk folder, if you should not receive an email from us within the next 2 hours, please try again or contact us thru following email address: {email}.</p>
<p>Kind regards<br />{title}</p>
</div>
</div>
</div>', 15, 17, NOW()),
(NULL, 0, 'en', 'Logout', '<div class=\"container\">
<div class=\"row\">
<div class=\"col-lg-12\">
<h2>Logout successfully</h2>
<p>You have been logged out successful.</p>
<p><a href=\"{url}\">Click here to go back to the home page</a></p>
</div>
</div>
</div>', 15, 18, NOW()),
(NULL, 0, 'en', 'Error', '<p>Hi!</p><p>An error occured, you might want to try again. It could be that your ip has been blocked, please contact us if you not aware off that.</p><p><a href=\"{url}\">Click here to go back to the home page</a></p>', 15, 19, NOW()),
(NULL, 0, 'en', 'New Ticket', '<p>Hi!</p>
<p>This message has been automatically generated in response to the creation of a support ticket regarding: \"{subject}\", a summary of which appears below. There is no need to reply to this message right now. Your ticket has been assigned an ID of {ticket}.</p>
<p>To do so, you may reply to this message, here: {ticketurl}</p>
<p>Thank you,<br />{title}</p>', 15, 20, NOW()),
(NULL, 0, 'en', 'Ticket Answer', '<p>Hi!</p>
<p>This message has been automatically generated in response to an answer of a support ticket regarding: \"{subject}\", a summary of which appears below.</p>
<p>Your ticket has following ID: {ticket}</p>
<p>You may reply to this message, here: {ticketurl}</p>
<p>Thank you,<br />{title}</p>', 15, 21, NOW()),
(NULL, 0, 'en', 'Ticket Reminder', '<p>Hi {cname},</p>
<p>This is a reminder of your ticket \"{subject}\".</p>
<p>The history of your ticket can be found in your dashboard or you can go straight to your ticket with following url: {ticketurl}</p>
<p>Kind regards<br />{title}</p>', 15, 22, NOW()),
(NULL, 0, 'en', 'Ticket closed', '<p>Hi {cname},</p>
<p>Your ticket \"{subject}\" has been closed.</p>
<p>The history of your ticket can be found in your dashboard or you can go straight to your ticket with following url: {ticketurl}</p>
<p>You can reopen the ticket, simply reply to it.</p>
<p>Kind regards<br />{title}</p>', 15, 23, NOW()),
(NULL, 0, 'en', 'Start Chat Client', 'Hi %client%, please start the chat below.', 15, 24, NOW()),
(NULL, 0, 'en', 'Support Rating', '<h3>How would you rate the support you received?</h3><p>Hello {cname},<br>We'd love to hear what you think of our customer service. Please take a moment to rate the support you have received by clicking the link below.<br>How would you rate the support you received?</p><p><a href=\"{ticketurl}\">Rate your ticket here</a></p>', 15, 25, NOW())");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."support_departments (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `description` mediumtext,
  `faq_url` text,
  `email` varchar(255) DEFAULT NULL,
  `credits` int(10) unsigned NOT NULL DEFAULT '0',
  `guesta` smallint(1) unsigned NOT NULL DEFAULT '1',
  `active` smallint(1) unsigned NOT NULL DEFAULT '1',
  `dorder` smallint(2) unsigned NOT NULL DEFAULT '1',
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `guesta` (`guesta`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."support_departments (`id`, `title`, `description`, `email`, `guesta`, `active`, `dorder`, `time`) VALUES
(1, 'First Support Department', 'Edit this text to your needs...', '', 1, 1, 1, NOW())");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."support_tickets (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `depid` int(10) unsigned NOT NULL DEFAULT '0',
  `operatorid` int(10) unsigned NOT NULL DEFAULT '0',
  `clientid` int(10) unsigned NOT NULL DEFAULT '0',
  `name` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `priorityid` int(10) unsigned NOT NULL DEFAULT '0',
  `toptionid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) DEFAULT NULL,
  `content` mediumtext,
  `ip` char(15) DEFAULT NULL,
  `referrer` varchar(255) DEFAULT NULL,
  `notes` text,
  `private` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `attachments` smallint(2) unsigned NOT NULL DEFAULT '0',
  `initiated` int(10) unsigned NOT NULL DEFAULT '0',
  `ended` int(10) unsigned NOT NULL DEFAULT '0',
  `updated` int(10) unsigned NOT NULL DEFAULT '0',
  `reminder` smallint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `depid` (`depid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."faq_categories (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `class` varchar(20) NOT NULL DEFAULT 'success',
  `title` varchar(255) DEFAULT NULL,
  `description` mediumtext,
  `email` varchar(255) DEFAULT NULL,
  `guesta` smallint(1) unsigned NOT NULL DEFAULT '1',
  `active` smallint(1) unsigned NOT NULL DEFAULT '1',
  `dorder` smallint(2) unsigned NOT NULL DEFAULT '1',
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."faq_categories (`id`, `title`, `description`, `email`, `guesta`, `active`, `dorder`, `time`) VALUES
(1, 'First FAQ Category', 'Edit this text to your needs...', '', 1, 1, 1, NOW())");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."faq_article (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `catid` int(10) NOT NULL DEFAULT '0',
  `lang` char(2) DEFAULT 'en',
  `title` varchar(255) DEFAULT NULL,
  `content` mediumtext,
  `socialbutton` smallint(1) unsigned NOT NULL DEFAULT 0,
  `votes` int(10) NOT NULL DEFAULT 0,
  `active` smallint(1) unsigned NOT NULL DEFAULT '1',
  `dorder` int(10) unsigned NOT NULL DEFAULT '1',
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `catid` (`catid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."faq_article (`id`, `catid`, `lang`, `title`, `content`, `active`, `dorder`, `time`) VALUES
(1, 1, 'en', 'First FAQ Entry', 'Edit this text to your needs...', 1, 1, NOW())");

$jakdb->query('ALTER TABLE '.JAKDB_PREFIX.'faq_article ADD FULLTEXT(`title`, `content`)');

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."ticket_answers (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ticketid` int(10) NOT NULL DEFAULT '0',
  `clientid` int(10) unsigned NOT NULL DEFAULT '0',
  `operatorid` int(10) unsigned NOT NULL DEFAULT '0',
  `content` mediumtext NOT NULL,
  `lastedit` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  `sent` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."ticketpriority (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `depid` int(10) NOT NULL DEFAULT '0',
  `title` varchar(100) DEFAULT NULL,
  `class` varchar(10) DEFAULT 'default',
  `oponly` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `credits` int(10) unsigned NOT NULL DEFAULT '0',
  `dorder` int(10) unsigned NOT NULL DEFAULT '1',
  `edited` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  `created` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `depid` (`depid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."ticketpriority (`id`, `depid`, `title`, `class`, `oponly`, `dorder`, `edited`, `created`) VALUES
(1, 0, 'Low', 'secondary', 0, 1, NOW(), NOW()),
(2, 0, 'Medium','warning', 0, 2, NOW(), NOW()),
(3, 0, 'High', 'danger', 0, 3, NOW(), NOW());");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."ticketoptions (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `depid` int(10) NOT NULL DEFAULT '0',
  `title` varchar(100) DEFAULT NULL,
  `icon` varchar(20) DEFAULT 'fa-bug',
  `oponly` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `credits` int(10) unsigned NOT NULL DEFAULT '0',
  `dorder` int(10) unsigned NOT NULL DEFAULT '1',
  `edited` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  `created` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `depid` (`depid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8");


$jakdb->query("INSERT INTO ".JAKDB_PREFIX."ticketoptions (`id`, `depid`, `title`, `icon`, `oponly`, `dorder`, `edited`, `created`) VALUES
(1, 0, 'Feedback', 'fa-commenting-o', 0, 1, NOW(), NOW()),
(2, 0, 'Support', 'fa-ambulance', 0, 2, NOW(), NOW()),
(3, 0, 'Bug Report', 'fa-bug', 0, 3, NOW(), NOW())");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."php_imap (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `depid` int(10) unsigned NOT NULL DEFAULT '0',
  `mailbox` varchar(255) DEFAULT NULL,
  `username` varchar(100) DEFAULT NULL,
  `password` varchar(30) DEFAULT NULL,
  `encryption` varchar(3) DEFAULT NULL,
  `scanfolder` varchar(30) DEFAULT NULL,
  `emailanswer` varchar(255) DEFAULT NULL,
  `msgdel` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `active` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `depid` (`depid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."clients (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `chat_dep` varchar(100) DEFAULT '0',
  `support_dep` varchar(100) DEFAULT '0',
  `faq_cat` varchar(100) DEFAULT '0',
  `email` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `picture` varchar(255) NOT NULL DEFAULT '/standard.jpg',
  `password` char(64) NOT NULL,
  `idhash` varchar(32) DEFAULT NULL,
  `session` varchar(64) DEFAULT NULL,
  `language` varchar(10) DEFAULT NULL,
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  `lastactivity` int(10) unsigned NOT NULL DEFAULT '0',
  `chatrequests` int(10) unsigned NOT NULL DEFAULT '0',
  `supportrequests` int(10) unsigned NOT NULL DEFAULT '0',
  `canupload` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `logins` int(10) unsigned NOT NULL DEFAULT '0',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `custom_price` smallint(3) NOT NULL DEFAULT '0',
  `credits` int(10) NOT NULL DEFAULT '0',
  `paid_until` date NOT NULL DEFAULT '1980-05-06',
  `forgot` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."support_responses (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `depid` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(100) NOT NULL,
  `message` mediumtext,
  PRIMARY KEY (`id`),
  KEY `depid` (`depid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=2");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."support_responses (`id`, `depid`, `title`, `message`) VALUES
(1, 0, 'Reply', 'Thank you for opening a support ticket with us.')");

$jakdb->query("CREATE TABLE IF NOT EXISTS ".JAKDB_PREFIX."blog (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `lang` char(2) DEFAULT 'en',
  `title` varchar(255) DEFAULT NULL,
  `content` mediumtext,
  `previmg` varchar(255) DEFAULT NULL,
  `active` smallint(1) unsigned NOT NULL DEFAULT 1,
  `showdate` smallint(1) unsigned NOT NULL DEFAULT 0,
  `comments` smallint(1) unsigned NOT NULL DEFAULT 0,
  `socialbutton` smallint(1) unsigned NOT NULL DEFAULT 0,
  `hits` int(10) unsigned NOT NULL DEFAULT 0,
  `membersonly` smallint(1) unsigned NOT NULL DEFAULT 0,
  `dorder` int(10) unsigned NOT NULL DEFAULT 1,
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `lang` (`lang`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."blog (`id`, `lang`, `title`, `content`, `previmg`, `active`, `showdate`, `comments`, `socialbutton`, `hits`, `membersonly`, `dorder`, `time`) VALUES
(1, 'en', 'Lorem Ipsum', '<p>Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.</p>', '/".JAK_FILES_DIRECTORY."/editor/bg-22.jpg', 1, 1, 1, 1, 0, 0, 1, NOW()),
(2, 'en', 'Lorem Ipsum 2', '<p>Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.</p>', '/".JAK_FILES_DIRECTORY."/editor/bg-003.jpg', 1, 1, 1, 1, 0, 0, 2, NOW()),
(3, 'en', 'Lorem Ipsum 3', '<p>Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.</p>', '/".JAK_FILES_DIRECTORY."/editor/bg-015.jpg', 1, 1, 1, 1, 0, 0, 3, NOW())");


$jakdb->query("CREATE TABLE IF NOT EXISTS ".JAKDB_PREFIX."blogcomments (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `blogid` int(10) unsigned NOT NULL DEFAULT 0,
  `commentid` int(10) unsigned NOT NULL DEFAULT 0,
  `clientid` int(10) unsigned NOT NULL DEFAULT 0,
  `operatorid` int(10) unsigned NOT NULL DEFAULT 0,
  `message` text,
  `approve` smallint(1) unsigned NOT NULL DEFAULT 0,
  `votes` int(10) NOT NULL DEFAULT 0,
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  `session` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `blogid` (`blogid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

$jakdb->query("CREATE TABLE IF NOT EXISTS ".JAKDB_PREFIX."billing_packages (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `content` mediumtext,
  `previmg` varchar(255) DEFAULT NULL,
  `credits` int(10) unsigned NOT NULL DEFAULT 0,
  `paidtill` varchar(100) DEFAULT NULL,
  `chat_dep` varchar(100) DEFAULT '0',
  `support_dep` varchar(100) DEFAULT '0',
  `faq_cat` varchar(100) DEFAULT '0',
  `amount` float NOT NULL DEFAULT '0',
  `currency` varchar(3) DEFAULT NULL,
  `dorder` int(10) unsigned NOT NULL DEFAULT 1,
  `active` smallint(1) unsigned NOT NULL DEFAULT 1,
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8");

$jakdb->query("CREATE TABLE IF NOT EXISTS ".JAKDB_PREFIX."subscriptions (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `clientid` int(10) unsigned NOT NULL DEFAULT '0',
  `amount` float NOT NULL DEFAULT '0',
  `currency` varchar(3) DEFAULT NULL,
  `package` int(10) unsigned NOT NULL DEFAULT 1,
  `paidhow` varchar(30) DEFAULT NULL,
  `paidwhen` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  `success` tinyint(3) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `clientid` (`clientid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8");

$jakdb->query("CREATE TABLE IF NOT EXISTS ".JAKDB_PREFIX."payment_ipn (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `clientid` int(10) unsigned NOT NULL DEFAULT '0',
  `status` varchar(200) DEFAULT NULL,
  `amount` varchar(200) DEFAULT NULL,
  `currency` varchar(200) DEFAULT NULL,
  `txn_id` varchar(200) DEFAULT NULL,
  `receiver_email` varchar(200) DEFAULT NULL,
  `payer_email` varchar(200) DEFAULT NULL,
  `paid_with` varchar(200) DEFAULT NULL,
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."cms_pages (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `lang` varchar(2) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `url_slug` varchar(255) DEFAULT NULL,
  `content` mediumtext,
  `ogimg` varchar(255) DEFAULT NULL,
  `meta_keywords` varchar(200) DEFAULT NULL,
  `meta_description` varchar(200) DEFAULT NULL,
  `dorder` int(10) NOT NULL DEFAULT '1',
  `showheader` tinyint(3) NOT NULL DEFAULT '1',
  `ishome` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `showfooter` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `prepage` varchar(50) NOT NULL DEFAULT '0',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '1',
  `active` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `edited` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  `created` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `lang` (`lang`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."cms_pages (`id`, `lang`, `title`, `url_slug`, `content`, `ogimg`, `meta_keywords`, `meta_description`, `dorder`, `showheader`, `ishome`, `showfooter`, `prepage`, `access`, `hits`, `active`, `edited`, `created`) VALUES
(1, 'en', 'Home', 'home', '<p>{searchblock}</p>\r\n<p>{blognew}</p>', '', 'helpdesk3,support,live-chat,faq,blog,cms', 'Get the next generation support desk software.', 1, 1, 1, 0, '0', 2, 3, 1, NOW(), NOW()),
(2, 'en', 'Support', 'support', '', '', '', '', 2, 1, 0, 1, 'support', 2, 5, 1, NOW(), NOW()),
(3, 'en', 'FAQ', 'faq', '', '', '', '', 3, 1, 0, 1, 'faq', 2, 3, 1, NOW(), NOW()),
(4, 'en', 'Blog', 'blog', '', '', '', '', 4, 1, 0, 1, 'blog', 2, 3, 1, NOW(), NOW()),
(5, 'en', 'Login', 'login', '<p>{login}</p>', '', '', '', 5, 1, 0, 1, '0', 1, 2, 1, NOW(), NOW()),
(6, 'en', 'Register', 'register', '<p>{register}</p>', NULL, NULL, NULL, 6, 1, 0, 1, '0', 1, 3, 1, NOW(), NOW()),
(7, 'en', 'Contact', 'get-in-touch', '<div class=\"container my-5\">\r\n<div class=\"row\">\r\n<div class=\"col-md-6\">\r\n<p>Feel free to contact us by the contact form at any time, we usually respond in less then 24 hours.</p>\r\n<address><strong>JAKWEB / Switzerland</strong><br /> Hch.Bosshardstrasse 26 / 8352 Elsau<br /> <abbr title=\"Phone\">Phone:</abbr> +41 (0)77 482 57 15<br /> <abbr title=\"Email\">Email:</abbr> info[at]jakweb.ch</address><hr />\r\n<div class=\"alert alert-info\"><strong>Heads up!</strong> For support please use our <a class=\"alert-link\" href=\"/support\">support</a> area.</div>\r\n</div>\r\n<div class=\"col-md-6\">\r\n<p>{contact}</p>\r\n</div>\r\n</div>\r\n</div>', '', '', '', 7, 1, 0, 1, '0', 2, 3, 1, NOW(), NOW()),
(8, 'en', 'Client', 'client', '', '', '', '', 8, 1, 0, 1, 'client', 3, 3, 1, NOW(), NOW()),
(9, 'en', 'Search', 'search', '', '', '', '', 9, 1, 0, 1, 'search', 2, 3, 1, NOW(), NOW())");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."translations (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `lang` varchar(2) DEFAULT NULL,
  `chat_dep` int(10) unsigned NOT NULL DEFAULT '0',
  `support_dep` int(10) unsigned NOT NULL DEFAULT '0',
  `faq_cat` int(10) unsigned NOT NULL DEFAULT '0',
  `priorityid` int(10) unsigned NOT NULL DEFAULT '0',
  `customfieldid` int(10) unsigned NOT NULL DEFAULT '0',
  `toptionid` int(10) unsigned NOT NULL DEFAULT '0',
  `cmsid` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) DEFAULT NULL,
  `description` mediumtext,
  `faq_url` text,
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `lang` (`lang`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

$jakdb->query("INSERT INTO ".JAKDB_PREFIX."translations (`id`, `lang`, `chat_dep`, `support_dep`, `faq_cat`, `priorityid`, `customfieldid`, `toptionid`, `cmsid`, `title`, `description`, `faq_url`, `time`) VALUES
(1, 'en', 0, 0, 0, 0, 0, 0, 1, '<h3>\r\n    Smart FAQ Search\r\n</h3>', '<p class=\"txt-small\">Search through our FAQ with the build in smart search.</p>', NULL, NOW()),
(2, 'en', 0, 0, 0, 0, 0, 0, 2, '<h3><strong>Help</strong> <small>Desk 3</small></h3>', '<p class=\"txt-small\">Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum.</p>\r\n<p class=\"mb-0\">Phone: <strong>+41 (0) 77 482 57 15</strong></p>\r\n<p>Email: <strong>youremail@domain.com</strong></p>', NULL, NOW()),
(3, 'en', 0, 0, 0, 0, 0, 0, 3, '<h4 class=\"title-green\">Features</h4>', NULL, NULL, NOW()),
(4, 'en', 0, 0, 0, 0, 0, 0, 4, '<h4 class=\"title-green\">About Us</h4>', NULL, NULL, NOW()),
(5, 'en', 0, 0, 0, 0, 0, 0, 5, '<h3 class=\"title-green\">\r\n    Latest News\r\n</h3>', '<p>Our blog will inform you about the latest news about our company.</p>', NULL, NOW()),
(6, 'en', 0, 0, 0, 0, 0, 0, 6, '<h4>Contact Form</h4>', '<p>Please fill at least the name, email and message field.</p>', NULL, NOW()),
(7, 'en', 0, 0, 0, 0, 0, 0, 7, '<h3 class=\"title-green\">Latest FAQ Articles</h3>', '<p>The latest FAQ article, browse through our frequently asked question database and get smart.</p>', NULL, NOW()),
(8, 'en', 0, 0, 0, 0, 0, 0, 8, '<h3 class=\"title-green\">Our FAQ Article</h3>', '<p>Check all our frequently asked questions and get smart.</p>', NULL, NOW()),
(9, 'en', 0, 0, 0, 0, 0, 0, 9, '<h3 class=\"title-green\">Latest Support Tickets</h3>', '<p>Our latest support tickets, grab some knowledge from our database.</p>', NULL, NOW()),
(10, 'en', 0, 0, 0, 0, 0, 0, 10, '<h3 class=\"title-green\">Support Tickets</h3>', '<p>Grab some knowledge from our public support tickets.</p>', NULL, NOW()),
(11, 'en', 0, 0, 0, 0, 0, 0, 11, '<h3>All Blog Articles</h3>', '<p>Check our latest articles now and in full length.</p>', NULL, NOW()),
(12, 'en', 0, 0, 0, 0, 0, 0, 12, '<h3>Client Dashboard</h3>', '<p>Welcome to your dashboard, you will find all your tickets, payments and profile information on this page.</p>', NULL, NOW()),
(13, 'en', 0, 0, 0, 0, 0, 0, 13, '<h3>Billing History</h3>', '<p>Your billing history on our site</p>', NULL, NOW()),
(14, 'en', 0, 0, 0, 0, 0, 0, 14, '<h3>Subscriptions</h3>', '<p>Select the package that suits you.</p>', NULL, NOW()),
(15, 'en', 0, 0, 0, 0, 0, 0, 15, '<h3>Edit Profile</h3>', '<p>Edit your profile add your personal avatar and get some nuts.</p>', NULL, NOW())");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."customfields (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `fieldlocation` tinyint(3) NOT NULL DEFAULT '1',
  `depid` int(10) unsigned NOT NULL DEFAULT 1,
  `title` varchar(255) DEFAULT NULL,
  `val_slug` varchar(255) DEFAULT NULL,
  `field_html` text,
  `fieldtype` tinyint(3) NOT NULL DEFAULT '1',
  `mandatory` tinyint(3) NOT NULL DEFAULT '0',
  `onregister` tinyint(3) NOT NULL DEFAULT '0',
  `dorder` int(10) unsigned NOT NULL DEFAULT 1,
  `active` tinyint(3) NOT NULL DEFAULT '1',
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `fieldlocation` (`fieldlocation`, `depid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."taken_credits (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `clientid` int(10) unsigned NOT NULL DEFAULT '0',
  `operatorid` int(10) unsigned NOT NULL DEFAULT '0',
  `credits` int(10) unsigned NOT NULL DEFAULT 0,
  `taken` tinyint(3) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `clientid` (`clientid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."events (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `userid` int(10) unsigned NOT NULL DEFAULT '0',
  `clientid` int(10) unsigned NOT NULL DEFAULT '0',
  `color` varchar(7) DEFAULT NULL,
  `start` datetime NOT NULL,
  `end` datetime DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `content` mediumtext,
  `url` varchar(255) DEFAULT NULL,
  `status` tinyint(3) NOT NULL DEFAULT '0',
  `lastedit` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  `created` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `userid` (`userid`,`clientid`,`start`,`end`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8");

$jakdb->query("CREATE TABLE ".JAKDB_PREFIX."ticket_rating (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `ticketid` int(10) unsigned NOT NULL DEFAULT '0',
  `clientid` int(10) unsigned NOT NULL DEFAULT '0',
  `vote` int(10) unsigned NOT NULL DEFAULT '0',
  `name` varchar(100) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `comment` text,
  `support_time` int(10) unsigned NOT NULL DEFAULT '0',
  `time` datetime NOT NULL DEFAULT '1980-05-06 00:00:00',
  PRIMARY KEY (`id`),
  KEY `ticketid` (`ticketid`,`clientid`,`vote`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

// confirm
$email_body = 'URL: '.BASE_URL.'<br />Email: '.JAK_EMAIL.'<br />License: '.JAK_O_NUMBER;

// Send the email to the customer
$mail = new PHPMailer(); // defaults to using php "mail()"
$body = str_ireplace("[\]", "", $email_body);
$mail->SetFrom(JAK_EMAIL);
$mail->AddReplyTo(JAK_EMAIL);
$mail->AddAddress('lic@jakweb.ch');
$mail->Subject = 'Update - HelpDesk 3 / 3.1';
$mail->AltBody = 'HTML Format';
$mail->MsgHTML($body);
$mail->Send();

// update time so css and javascript will be loaded fresh
$jakdb->query('UPDATE '.JAKDB_PREFIX.'settings SET used_value = "'.time().'" WHERE varname = "updated"');
// update version
$jakdb->query('UPDATE '.JAKDB_PREFIX.'settings SET used_value = "3.1" WHERE varname = "version"');

$succesfully = 1;

// Now let us delete all cache files
$cacheallfiles = '../'.JAK_CACHE_DIRECTORY.'/';
$msfi = glob($cacheallfiles."*.php");
if ($msfi) foreach ($msfi as $filen) {
    if (file_exists($filen)) unlink($filen);
}

?>
<div class="alert alert-success">Database update successfully, please delete the <strong>install</strong> directory and then login into your <a href="../operator/">operator</a> panel.</div>
<?php } ?>

<?php if (!$succesfully) { ?>
<div class="alert alert-info">Please follow this steps carefully before you update the database!</div>
<ul>
	<li>Backup all your files and your database.</li>
	<li>Upload all folders and files from the new version.</li>
	<li>Be sure to have a backup from your database before you update!</li>
	<li>Do you have an up to date backup from your database? OK, hit "Update Database".</li>
</ul>

<form name="company" method="post" action="update.php?step=2" enctype="multipart/form-data">

<div class="form-actions">
<button type="submit" name="update" class="btn btn-primary pull-right">Update Database</button>
</div>

</form>
<?php } } ?>

</div>
</div>

</div>

</div><!-- #container -->
</body>
</html>