<?php

/*===============================================*\
|| ############################################# ||
|| # JAKWEB.CH / Version 3.1                   # ||
|| # ----------------------------------------- # ||
|| # Copyright 2018 JAKWEB All Rights Reserved # ||
|| ############################################# ||
\*===============================================*/

// Check if the file is accessed only via index.php if not stop the script from running
if (!defined('JAK_ADMIN_PREVENT_ACCESS')) die('You cannot access this file directly.');


// Check if the user has access to this file
if (!jak_get_access("departments", $jakuser->getVar("permissions"), JAK_SUPERADMINACCESS)) jak_redirect(BASE_URL);

// All the tables we need for this plugin
$errors = array();
$jaktable = 'departments';
$jaktable1 = 'support_departments';
$jaktable2 = 'faq_categories';
$jaktable3 = 'translations';

// Reset some vars
$newdep = true;

// Call the language function
$lang_files = jak_get_lang_files(JAK_LANG);

// Now start with the plugin use a switch to access all pages
switch ($page1) {

	case 'support':

		switch ($page2) {
			case 'delete':
				// Remove department
				if (is_numeric($page3) && $page3 != 1) {
				        
					// Now check how many languages are installed and do the dirty work
					$result = $jakdb->delete($jaktable1, ["id" => $page3]);
				
					if (!$result) {
				    	$_SESSION["infomsg"] = $jkl['i'];
				    	jak_redirect($_SESSION['LCRedirect']);
					} else {
					
						// Now let us delete the define cache file
						$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
						if (file_exists($cachestufffile)) {
							unlink($cachestufffile);
						}

						// Delete translations
						$jakdb->delete($jaktable3, ["support_dep" => $page3]);
					
				    	$_SESSION["successmsg"] = $jkl['g14'];
				    	jak_redirect($_SESSION['LCRedirect']);
					}
				    
				} else {
				   	$_SESSION["errormsg"] = $jkl['i3'];
				    jak_redirect($_SESSION['LCRedirect']);
				}
			break;
			case 'edit':
				// Check if department exists
				if (is_numeric($page3) && jak_row_exist($page3,$jaktable1)) {
				
					if ($_SERVER['REQUEST_METHOD'] == 'POST') {
				    $jkp = $_POST;
				
				    if (empty($jkp['title'])) {
				        $errors['e'] = $jkl['e2'];
				    }
				    
				    if ($jkp['email'] != '' && !filter_var($jkp['email'], FILTER_VALIDATE_EMAIL)) { 
				    	$errors['e1'] = $jkl['e3'];
				    }
				    
				    if (count($errors) == 0) {

				    	$result = $jakdb->update($jaktable1, ["title" => $jkp['title'],
							"description" => $jkp['description'],
							"faq_url" => $jkp['faq'],
							"credits" => $jkp['credits'],
							"email" => $jkp['email'],
							"guesta" => $jkp['jak_guesta'],
							"#time" => "NOW()"], ["id" => $page3]);
				
						if (!$result) {
						    $_SESSION["infomsg"] = $jkl['i'];
				    		jak_redirect($_SESSION['LCRedirect']);
						} else {

							// Now we store the translations, that will be nasty
							if (isset($lang_files) && is_array($lang_files)) foreach($lang_files as $lf) {
								if (isset($jkp['title_'.$lf]) && !empty($jkp['title_'.$lf])) {
									// Now check if the language already exist
									if ($jakdb->has($jaktable3, ["AND" => ["support_dep" => $page3, "lang" => $lf]])) {
										$jakdb->update($jaktable3, ["title" => $jkp['title_'.$lf], "description" => $jkp['description_'.$lf], "faq_url" => $jkp['faqurl_'.$lf]], ["AND" => ["support_dep" => $page3, "lang" => $lf]]);
									} else {
										$jakdb->insert($jaktable3, ["lang" => $lf, "support_dep" => $page3, "title" => $jkp['title_'.$lf], "description" => $jkp['description_'.$lf], "faq_url" => $jkp['faqurl_'.$lf], "#time" => "NOW()"]);
									}
								}
								// Delete the entry
								if (isset($jkp['deltrans_'.$lf]) && !empty($jkp['deltrans_'.$lf])) {
									$jakdb->delete($jaktable3, ["AND" => ["support_dep" => $page3, "lang" => $jkp['deltrans_'.$lf]]]);
								}
							}
							
							// Now let us delete the define cache file
							$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
							if (file_exists($cachestufffile)) {
								unlink($cachestufffile);
							}
							
						    $_SESSION["successmsg"] = $jkl['g14'];
				    		jak_redirect(JAK_rewrite::jakParseurl('departments'));
						}
				
				// Output the errors
				} else {
				
				    $errors = $errors;
				}
				
				}
					// Title and Description
					$SECTION_TITLE = $jkl["m17"];
					$SECTION_DESC = "";

					// Get translations
					$JAK_DEP_TRANSLATION = $jakdb->select($jaktable3, ["id", "lang", "title", "description", "faq_url"], ["support_dep" => $page3]);
				
					$JAK_FORM_DATA = jak_get_data($page3, $jaktable1);
					$template = 'editdepartment.php';
				
				} else {
				   	$_SESSION["errormsg"] = $jkl['i3'];
				    jak_redirect($_SESSION['LCRedirect']);
				}
			break;
			case 'lock':
				// Set department status
				if (is_numeric($page3) && $page3 != 1) {

					// Check what we have to do
					$datausrac = $jakdb->get($jaktable1, "active", ["id" => $page3]);
					// update the table
					if ($datausrac) {
						$result = $jakdb->update($jaktable1, ["active" => 0], ["id" => $page3]);
					} else {
						$result = $jakdb->update($jaktable1, ["active" => 1], ["id" => $page3]);
					}
					
					if (!$result) {
						$_SESSION["infomsg"] = $jkl['i'];
				    	jak_redirect($_SESSION['LCRedirect']);
					} else {
						
						// Now let us delete the define cache file
						$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
						if (file_exists($cachestufffile)) {
							unlink($cachestufffile);
						}
						
					    $_SESSION["successmsg"] = $jkl['g14'];
				    	jak_redirect($_SESSION['LCRedirect']);
					}
				
				} else {
				   	$_SESSION["errormsg"] = $jkl['i3'];
				    jak_redirect($_SESSION['LCRedirect']);
				}
			break;
			default:
				# code...
					if ($_SERVER['REQUEST_METHOD'] == 'POST') {
				    $jkp = $_POST;

				    // Hosting is active we need to count the total operators
					if ($jakhs['hostactive']) {
						$totaldep = $jakdb->count($jaktable1);

						if ($totaldep >= $jakhs['departments']) {
							$_SESSION["errormsg"] = $jkl['i6'];
				    		jak_redirect($_SESSION['LCRedirect']);
						}
					}
				    
				    if (isset($_POST['insert_department'])) {
				    
				    if (empty($jkp['title'])) {
				    	$errors['e'] = $jkl['e2'];
				    }
				    
				    if ($jkp['email'] != '' && !filter_var($jkp['email'], FILTER_VALIDATE_EMAIL)) { 
				    	$errors['e1'] = $jkl['e3'];
				    }
				        
				    if (count($errors) == 0) {

				    	// Get the next order
				    	$last = $jakdb->get($jaktable1, "dorder", ["ORDER" => ["dorder" => "DESC"]]);
				    	$last = $last + 1;

				    	$jakdb->insert($jaktable1, ["title" => $jkp['title'],
							"description" => $jkp['description'],
							"email" => $jkp['email'],
							"faq_url" => $jkp['faq'],
							"credits" => $jkp['credits'],
							"guesta" => $jkp['jak_guesta'],
							"dorder" => $last,
							"#time" => "NOW()"]);

				    	$lastid = $jakdb->id();
				    
				    	if (!$lastid) {
				    		$_SESSION["infomsg"] = $jkl['i'];
				    		jak_redirect($_SESSION['LCRedirect']);
				    	} else {
				    			
				    		// Now let us delete the define cache file
				    		$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
				    		if (file_exists($cachestufffile)) {
				    			unlink($cachestufffile);
				    		}
				    			
				    		$_SESSION["successmsg"] = $jkl['g14'];
				    		jak_redirect($_SESSION['LCRedirect']);
				    	}
				    
				    // Output the errors
				    } else {
				    
				        $errors = $errors;
				    }
				 }
				    
				 if (isset($jkp['corder']) && isset($jkp['real_dep_id'])) {
				     
				 	$dorders = $jkp['corder'];
				    $depid = $jkp['real_dep_id'];
				    $realid = implode(',', $jkp['real_dep_id']);
				    $dep = array_combine($depid, $dorders);
				    $updatesql = '';       
				   	
				   	foreach ($dep as $key => $department) {
				    	$result = $jakdb->update($jaktable1, ["dorder" => $key], ["id" => $department]);
				    }
				             
				    if (!$result) {
				 		$_SESSION["infomsg"] = $jkl['i'];
				    	jak_redirect($_SESSION['LCRedirect']);
				 	} else {
				 	
				 		// Now let us delete the define cache file
				 		$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
				 		if (file_exists($cachestufffile)) {
				 			unlink($cachestufffile);
				 		}
				 	
				     	$_SESSION["successmsg"] = $jkl['g14'];
				    	jak_redirect($_SESSION['LCRedirect']);
				 	}
				 	
				 }
				    
		   
				 }
				
				// Get all departments
				$DEPARTMENTS_ALL = $jakdb->select($jaktable1, "*", ["ORDER" => ["dorder" => "ASC"]]);

				// Hosting is active we need to count the total departments
				if ($jakhs['hostactive']) {
					$totaldep = $jakdb->count($jaktable1);
					if ($totaldep >= $jakhs['departments']) $newdep = false;
				}
				 
				// Title and Description
				$SECTION_TITLE = $jkl["hd3"];
				$SECTION_DESC = "";
				
				// Include the javascript file for results
				$js_file_footer = 'js_pages.php';
				
				// Call the template
				$template = 'departments.php';
			break;
		}

	break;
	case 'faq':

		switch ($page2) {
			case 'delete':
				# code...
				// Check if user exists and can be deleted
				if (is_numeric($page3) && $page3 != 1) {
				        
					// Now check how many languages are installed and do the dirty work
					$result = $jakdb->delete($jaktable2, ["id" => $page3]);
				
					if (!$result) {
				    	$_SESSION["infomsg"] = $jkl['i'];
				    	jak_redirect($_SESSION['LCRedirect']);
					} else {
					
						// Now let us delete the define cache file
						$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
						if (file_exists($cachestufffile)) {
							unlink($cachestufffile);
						}

						// Delete translations
						$jakdb->delete($jaktable3, ["faq_cat" => $page3]);
					
				    	$_SESSION["successmsg"] = $jkl['g14'];
				    	jak_redirect($_SESSION['LCRedirect']);
					}
				    
				} else {
				   	$_SESSION["errormsg"] = $jkl['i3'];
				    jak_redirect($_SESSION['LCRedirect']);
				}
			break;
			case 'edit':
				// Check if the department exists
				if (is_numeric($page3) && jak_row_exist($page3,$jaktable2)) {
				
					if ($_SERVER['REQUEST_METHOD'] == 'POST') {
				    $jkp = $_POST;
				
				    if (empty($jkp['title'])) {
				        $errors['e'] = $jkl['e2'];
				    }
				    
				    if ($jkp['email'] != '' && !filter_var($jkp['email'], FILTER_VALIDATE_EMAIL)) { 
				    	$errors['e1'] = $jkl['e3'];
				    }
				    
				    if (count($errors) == 0) {

				    	$result = $jakdb->update($jaktable2, ["class" => $jkp["jak_class"],
				    		"title" => $jkp['title'],
							"description" => $jkp['description'],
							"email" => $jkp['email'],
							"guesta" => $jkp['jak_guesta'],
							"#time" => "NOW()"], ["id" => $page3]);
				
						if (!$result) {
						    $_SESSION["infomsg"] = $jkl['i'];
				    		jak_redirect($_SESSION['LCRedirect']);
						} else {

							// Now we store the translations, that will be nasty
							if (isset($lang_files) && is_array($lang_files)) foreach($lang_files as $lf) {
								if (isset($jkp['title_'.$lf]) && !empty($jkp['title_'.$lf])) {
									// Now check if the language already exist
									if ($jakdb->has($jaktable3, ["AND" => ["faq_cat" => $page3, "lang" => $lf]])) {
										$jakdb->update($jaktable3, ["title" => $jkp['title_'.$lf], "description" => $jkp['description_'.$lf]], ["AND" => ["depid" => $page2, "lang" => $lf]]);
									} else {
										$jakdb->insert($jaktable3, ["lang" => $lf, "faq_cat" => $page3, "title" => $jkp['title_'.$lf], "description" => $jkp['description_'.$lf], "#time" => "NOW()"]);
									}
								}
								// Delete the entry
								if (isset($jkp['deltrans_'.$lf]) && !empty($jkp['deltrans_'.$lf])) {
									$jakdb->delete($jaktable3, ["AND" => ["faq_cat" => $page3, "lang" => $jkp['deltrans_'.$lf]]]);
								}
							}
							
							// Now let us delete the define cache file
							$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
							if (file_exists($cachestufffile)) {
								unlink($cachestufffile);
							}
							
						    $_SESSION["successmsg"] = $jkl['g14'];
				    		jak_redirect(JAK_rewrite::jakParseurl('departments'));
						}
				
				// Output the errors
				} else {
				
				    $errors = $errors;
				}
				
				}
					// Title and Description
					$SECTION_TITLE = $jkl["hd19"];
					$SECTION_DESC = "";

					// Get translations
					$JAK_DEP_TRANSLATION = $jakdb->select($jaktable3, ["id", "lang", "title", "description"], ["faq_cat" => $page3]);
				
					$JAK_FORM_DATA = jak_get_data($page3, $jaktable2);
					$template = 'editdepartment.php';
				
				} else {
				   	$_SESSION["errormsg"] = $jkl['i3'];
				    jak_redirect($_SESSION['LCRedirect']);
				}
			break;
			case 'lock':
				// Set department status
				if (is_numeric($page3) && $page3 != 1) {

					// Check what we have to do
					$datausrac = $jakdb->get($jaktable2, "active", ["id" => $page3]);
					// update the table
					if ($datausrac) {
						$result = $jakdb->update($jaktable2, ["active" => 0], ["id" => $page3]);
					} else {
						$result = $jakdb->update($jaktable2, ["active" => 1], ["id" => $page3]);
					}
					
					if (!$result) {
						$_SESSION["infomsg"] = $jkl['i'];
				    	jak_redirect($_SESSION['LCRedirect']);
					} else {
						
						// Now let us delete the define cache file
						$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
						if (file_exists($cachestufffile)) {
							unlink($cachestufffile);
						}
						
					    $_SESSION["successmsg"] = $jkl['g14'];
				    	jak_redirect($_SESSION['LCRedirect']);
					}
				
				} else {
				   	$_SESSION["errormsg"] = $jkl['i3'];
				    jak_redirect($_SESSION['LCRedirect']);
				}
			break;
			default:
				# code...
					if ($_SERVER['REQUEST_METHOD'] == 'POST') {
				    $jkp = $_POST;

				    // Hosting is active we need to count the total operators
					if ($jakhs['hostactive']) {
						$totaldep = $jakdb->count($jaktable2);

						if ($totaldep >= $jakhs['departments']) {
							$_SESSION["errormsg"] = $jkl['i6'];
				    		jak_redirect($_SESSION['LCRedirect']);
						}
					}
				    
				    if (isset($_POST['insert_department'])) {
				    
				    if (empty($jkp['title'])) {
				    	$errors['e'] = $jkl['e2'];
				    }
				    
				    if ($jkp['email'] != '' && !filter_var($jkp['email'], FILTER_VALIDATE_EMAIL)) { 
				    	$errors['e1'] = $jkl['e3'];
				    }
				        
				    if (count($errors) == 0) {

				    	// Get the next order
				    	$last = $jakdb->get($jaktable2, "dorder", ["ORDER" => ["dorder" => "DESC"]]);
				    	$last = $last + 1;

				    	$jakdb->insert($jaktable2, ["title" => $jkp['title'],
							"description" => $jkp['description'],
							"email" => $jkp['email'],
							"guesta" => $jkp['jak_guesta'],
							"dorder" => $last,
							"#time" => "NOW()"]);

				    	$lastid = $jakdb->id();
				    
				    	if (!$lastid) {
				    		$_SESSION["infomsg"] = $jkl['i'];
				    		jak_redirect($_SESSION['LCRedirect']);
				    	} else {
				    			
				    		// Now let us delete the define cache file
				    		$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
				    		if (file_exists($cachestufffile)) {
				    			unlink($cachestufffile);
				    		}
				    			
				    		$_SESSION["successmsg"] = $jkl['g14'];
				    		jak_redirect($_SESSION['LCRedirect']);
				    	}
				    
				    // Output the errors
				    } else {
				    
				        $errors = $errors;
				    }
				 }
				    
				 if (isset($jkp['corder']) && isset($jkp['real_dep_id'])) {
				     
				 	$dorders = $jkp['corder'];
				    $depid = $jkp['real_dep_id'];
				    $realid = implode(',', $jkp['real_dep_id']);
				    $dep = array_combine($depid, $dorders);
				    $updatesql = '';       
				   	
				   	foreach ($dep as $key => $department) {
				    	$result = $jakdb->update($jaktable2, ["dorder" => $key], ["id" => $department]);
				    }
				             
				    if (!$result) {
				 		$_SESSION["infomsg"] = $jkl['i'];
				    	jak_redirect($_SESSION['LCRedirect']);
				 	} else {
				 	
				 		// Now let us delete the define cache file
				 		$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
				 		if (file_exists($cachestufffile)) {
				 			unlink($cachestufffile);
				 		}
				 	
				     	$_SESSION["successmsg"] = $jkl['g14'];
				    	jak_redirect($_SESSION['LCRedirect']);
				 	}
				 	
				 }
				    
		   
				 }
				
				// Get all departments
				$DEPARTMENTS_ALL = $jakdb->select($jaktable2, "*", ["ORDER" => ["dorder" => "ASC"]]);

				// Hosting is active we need to count the total departments
				if ($jakhs['hostactive']) {
					$totaldep = $jakdb->count($jaktable2);
					if ($totaldep >= $jakhs['departments']) $newdep = false;
				}
				 
				// Title and Description
				$SECTION_TITLE = $jkl["hd4"];
				$SECTION_DESC = "";
				
				// Include the javascript file for results
				$js_file_footer = 'js_pages.php';
				
				// Call the template
				$template = 'departments.php';
			break;
		}

	break;
	case 'delete':
		 
		// Check if user exists and can be deleted
		if (is_numeric($page2) && $page2 != 1) {
		        
			// Now check how many languages are installed and do the dirty work
			$result = $jakdb->delete($jaktable, ["id" => $page2]);
		
			if (!$result) {
		    	$_SESSION["infomsg"] = $jkl['i'];
		    	jak_redirect($_SESSION['LCRedirect']);
			} else {
			
				// Now let us delete the define cache file
				$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
				if (file_exists($cachestufffile)) {
					unlink($cachestufffile);
				}

				// Delete translations
				$jakdb->delete($jaktable3, ["chat_dep" => $page3]);
			
		    	$_SESSION["successmsg"] = $jkl['g14'];
		    	jak_redirect($_SESSION['LCRedirect']);
			}
		    
		} else {
		   	$_SESSION["errormsg"] = $jkl['i3'];
		    jak_redirect($_SESSION['LCRedirect']);
		}
		
	break;
	case 'edit':
	
		// Check if the user exists
		if (is_numeric($page2) && jak_row_exist($page2,$jaktable)) {
		
			if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		    $jkp = $_POST;
		
		    if (empty($jkp['title'])) {
		        $errors['e'] = $jkl['e2'];
		    }
		    
		    if ($jkp['email'] != '' && !filter_var($jkp['email'], FILTER_VALIDATE_EMAIL)) { 
		    	$errors['e1'] = $jkl['e3'];
		    }
		    
		    if (count($errors) == 0) {

		    	$result = $jakdb->update($jaktable, ["title" => $jkp['title'],
					"description" => $jkp['description'],
					"email" => $jkp['email'],
					"faq_url" => $jkp['faq'],
					"credits" => $jkp['credits'],
					"guesta" => $jkp['jak_guesta'],
					"#time" => "NOW()"], ["id" => $page2]);
		
				if (!$result) {
				    $_SESSION["infomsg"] = $jkl['i'];
		    		jak_redirect($_SESSION['LCRedirect']);
				} else {

					// Now we store the translations, that will be nasty
					if (isset($lang_files) && is_array($lang_files)) foreach($lang_files as $lf) {
						if (isset($jkp['title_'.$lf]) && !empty($jkp['title_'.$lf])) {
							// Now check if the language already exist
							if ($jakdb->has($jaktable3, ["AND" => ["chat_dep" => $page2, "lang" => $lf]])) {
								$jakdb->update($jaktable3, ["title" => $jkp['title_'.$lf], "description" => $jkp['description_'.$lf], "faq_url" => $jkp['faqurl_'.$lf]], ["AND" => ["chat_dep" => $page2, "lang" => $lf]]);
							} else {
								$jakdb->insert($jaktable3, ["lang" => $lf, "chat_dep" => $page2, "title" => $jkp['title_'.$lf], "description" => $jkp['description_'.$lf], "faq_url" => $jkp['faqurl_'.$lf], "#time" => "NOW()"]);
							}
						}
						// Delete the entry
						if (isset($jkp['deltrans_'.$lf]) && !empty($jkp['deltrans_'.$lf])) {
							$jakdb->delete($jaktable3, ["AND" => ["chat_dep" => $page2, "lang" => $jkp['deltrans_'.$lf]]]);
						}
					}

					// Now let us delete the define cache file
					$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
					if (file_exists($cachestufffile)) {
						unlink($cachestufffile);
					}
					
				    $_SESSION["successmsg"] = $jkl['g14'];
		    		jak_redirect($_SESSION['LCRedirect']);
				}
		
		// Output the errors
		} else {
		
		    $errors = $errors;
		}
		
		}
			// Title and Description
			$SECTION_TITLE = $jkl["m17"];
			$SECTION_DESC = "";

			// Get translations
			$JAK_DEP_TRANSLATION = $jakdb->select($jaktable3, ["id", "lang", "title", "description", "faq_url"], ["chat_dep" => $page2]);
		
			$JAK_FORM_DATA = jak_get_data($page2, $jaktable);
			$template = 'editdepartment.php';
		
		} else {
		   	$_SESSION["errormsg"] = $jkl['i3'];
		    jak_redirect(JAK_rewrite::jakParseurl('departments'));
		}
		
	break;
	case 'lock':
	
		// Check if user exists and can be deleted
		if (is_numeric($page2) && $page2 != 1) {

			// Check what we have to do
			$datausrac = $jakdb->get($jaktable, "active", ["id" => $page2]);
			// update the table
			if ($datausrac) {
				$result = $jakdb->update($jaktable, ["active" => 0], ["id" => $page2]);
			} else {
				$result = $jakdb->update($jaktable, ["active" => 1], ["id" => $page2]);
			}
			
			if (!$result) {
				$_SESSION["infomsg"] = $jkl['i'];
		    jak_redirect($_SESSION['LCRedirect']);
			} else {
				
				// Now let us delete the define cache file
				$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
				if (file_exists($cachestufffile)) {
					unlink($cachestufffile);
				}
				
			    $_SESSION["successmsg"] = $jkl['g14'];
		    jak_redirect($_SESSION['LCRedirect']);
			}
		
		} else {
		   	$_SESSION["errormsg"] = $jkl['i3'];
		    jak_redirect($_SESSION['LCRedirect']);
		}
	
	break;
	default:
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		    $jkp = $_POST;

		    // Hosting is active we need to count the total operators
			if ($jakhs['hostactive']) {
				$totaldep = $jakdb->count($jaktable);

				if ($totaldep >= $jakhs['departments']) {
					$_SESSION["errormsg"] = $jkl['i6'];
		    		jak_redirect($_SESSION['LCRedirect']);
				}
			}
		    
		    if (isset($_POST['insert_department'])) {
		    
		    if (empty($jkp['title'])) {
		    	$errors['e'] = $jkl['e2'];
		    }
		    
		    if ($jkp['email'] != '' && !filter_var($jkp['email'], FILTER_VALIDATE_EMAIL)) { 
		    	$errors['e1'] = $jkl['e3'];
		    }
		        
		    if (count($errors) == 0) {

		    	// Get the next order
		    	$last = $jakdb->get($jaktable, "dorder", ["ORDER" => ["dorder" => "DESC"]]);
		    	$last = $last + 1;

		    	$jakdb->insert($jaktable, ["title" => $jkp['title'],
					"description" => $jkp['description'],
					"email" => $jkp['email'],
					"faq_url" => $jkp['faq'],
					"credits" => $jkp['credits'],
					"guesta" => $jkp['jak_guesta'],
					"dorder" => $last,
					"#time" => "NOW()"]);

		    	$lastid = $jakdb->id();
		    
		    	if (!$lastid) {
		    		$_SESSION["infomsg"] = $jkl['i'];
		    		jak_redirect($_SESSION['LCRedirect']);
		    	} else {
		    			
		    		// Now let us delete the define cache file
		    		$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
		    		if (file_exists($cachestufffile)) {
		    			unlink($cachestufffile);
		    		}
		    			
		    		$_SESSION["successmsg"] = $jkl['g14'];
		    		jak_redirect($_SESSION['LCRedirect']);
		    	}
		    
		    // Output the errors
		    } else {
		    
		        $errors = $errors;
		    }
		 }
		    
		 if (isset($jkp['corder']) && isset($jkp['real_dep_id'])) {
		     
		 	$dorders = $jkp['corder'];
		    $depid = $jkp['real_dep_id'];
		    $realid = implode(',', $jkp['real_dep_id']);
		    $dep = array_combine($depid, $dorders);
		    $updatesql = '';       
		   	
		   	foreach ($dep as $key => $department) {
		    	$result = $jakdb->update($jaktable, ["dorder" => $key], ["id" => $department]);
		    }
		             
		    if (!$result) {
		 		$_SESSION["infomsg"] = $jkl['i'];
		    	jak_redirect($_SESSION['LCRedirect']);
		 	} else {
		 	
		 		// Now let us delete the define cache file
		 		$cachestufffile = APP_PATH.JAK_CACHE_DIRECTORY.'/stuff.php';
		 		if (file_exists($cachestufffile)) {
		 			unlink($cachestufffile);
		 		}
		 	
		     	$_SESSION["successmsg"] = $jkl['g14'];
		    	jak_redirect($_SESSION['LCRedirect']);
		 	}
		 	
		 }
		    
   
		 }
		
		// Get all departments
		$DEPARTMENTS_ALL = $jakdb->select($jaktable, "*", ["ORDER" => ["dorder" => "ASC"]]);

		// Hosting is active we need to count the total departments
		if ($jakhs['hostactive']) {
			$totaldep = $jakdb->count($jaktable);
			if ($totaldep >= $jakhs['departments']) $newdep = false;
		}
		 
		// Title and Description
		$SECTION_TITLE = $jkl["hd2"];
		$SECTION_DESC = "";
		
		// Include the javascript file for results
		$js_file_footer = 'js_pages.php';
		
		// Call the template
		$template = 'departments.php';
}
?>