<?php

/*===============================================*\
|| ############################################# ||
|| # JAKWEB.CH / Version 3.1.1                 # ||
|| # ----------------------------------------- # ||
|| # Copyright 2018 JAKWEB All Rights Reserved # ||
|| ############################################# ||
\*===============================================*/

// Check if the file is accessed only via index.php if not stop the script from running
if (!defined('JAK_ADMIN_PREVENT_ACCESS')) die('You cannot access this file directly.');

// Check if the user has access to this file
if (!jak_get_access("support", $jakuser->getVar("permissions"), JAK_SUPERADMINACCESS)) jak_redirect(BASE_URL);

// All the tables we need for this plugin
$errors = array();
$jaktable = 'support_tickets';
$jaktable1 = 'support_departments';
$jaktable2 = 'support_responses';
$jaktable3 = 'ticketpriority';
$jaktable4 = 'ticket_answers';
$jaktable5 = 'clients';
$jaktable6 = 'user';
$jaktable7 = 'php_imap';
$jaktable8 = 'ticketoptions';

switch ($page1) {
  case 'new':
    // Reset some stuff
    $userid = $depid = 0;
    $jkp = "";
    
      if ($_SERVER['REQUEST_METHOD'] == 'POST') {
        $jkp = $_POST;

        if (isset($jkp['start-fresh']) && !empty($jkp['start-fresh'])) {
          unset($_SESSION["userinfo"]);
          unset($_SESSION["depinfo"]);
          $_SESSION["successmsg"] = $jkl['g14'];
          jak_redirect($_SESSION['LCRedirect']);
        }

        if (isset($jkp['jak_clients']) && !empty($jkp['jak_clients'])) {
          $_SESSION["userinfo"] = $jkp['jak_clients'];
          $_SESSION["successmsg"] = $jkl['g14'];
          jak_redirect($_SESSION['LCRedirect']);
        }

        if (isset($jkp['jak_depid']) && is_numeric($jkp['jak_depid']) && $jkp['jak_depid'] != 0) {
          $_SESSION["depinfo"] = $jkp['jak_depid'];
          $_SESSION["successmsg"] = $jkl['g14'];
          jak_redirect($_SESSION['LCRedirect']);
        }

        if (!isset($_SESSION["userinfo"])) {
          $errors['e'] = $jkl['hd199'];

        } elseif (!$_SESSION["depinfo"]) {
          $errors['e'] = $jkl['hd200'];
        } else {
    
          if (empty($jkp['subject'])) {
              $errors['e'] = $jkl['e2'];
          }
          
          if (empty($jkp['content'])) { 
            $errors['e1'] = $jkl['e1'];
          }

        }
        
        if (count($errors) == 0) {

          // Get the selected clientid
          $saveclientid = explode(":#:", $_SESSION["userinfo"]);

          // Get the client data once again
          $client_save = $jakdb->get($jaktable5, ["name", "email", "credits", "paid_until"], ["id" => $saveclientid[0]]);

          // Filter the subject
          $subjectf = filter_var($jkp['subject'], FILTER_SANITIZE_STRING);

          // Filter the notes
          $notesf = filter_var($jkp['jak_notes'], FILTER_SANITIZE_STRING);

          // Filter the content
          $contentf = jak_clean_safe_userpost($jkp['content']);

          // Create the ticket
          $result = $jakdb->insert($jaktable, ["depid" => $_SESSION["depinfo"],
          "subject" => $subjectf,
          "content" => $contentf,
          "operatorid" => $jkp['jak_operator'],
          "clientid" => $saveclientid[0],
          "name" => $client_save["name"],
          "email" => $client_save["email"],
          "referrer" => filter_var($jkp['jak_referrer'], FILTER_SANITIZE_STRING),
          "notes" => $notesf,
          "private" => $jkp['jak_private'],
          "priorityid" => $jkp['jak_priority'],
          "toptionid" => $jkp['jak_toption'],
          "status" => $jkp['jak_status'],
          "ip" => $ipa,
          "updated" => time(),
          "initiated" => time()]);
    
        if (!$result) {
            $_SESSION["infomsg"] = $jkl['i'];
            jak_redirect($_SESSION['LCRedirect']);
        } else {

            // Get the ID from the ticket
            $lastid = $jakdb->id();

            if ($jkp['jak_status'] == 3) {
              $jakdb->update($jaktable, ["ended" => time()], ["id" => $lastid]);
            }

            // And we complete the custom fields
            $formfields = $jakdb->select('customfields', "val_slug", ["fieldlocation" => 2]);
            if (isset($formfields) && !empty($formfields)) {
              foreach ($formfields as $v) {
                if (isset($jkp[$v]) && is_array($jkp[$v])) {
                  $joinval = join(',', $jkp[$v]);
                  $jakdb->update($jaktable, [$v => filter_var($joinval, FILTER_SANITIZE_STRING)], ["id" => $lastid]);
                } else {
                  $jakdb->update($jaktable, [$v => filter_var($jkp[$v], FILTER_SANITIZE_STRING)], ["id" => $lastid]);
                }
              }
            }

            // Set the client ticket request +1
            $jakdb->update($jaktable5, ["supportrequests[+]" => 1], ["id" => $saveclientid[0]]);

            // We run on a credit based system?
            if (JAK_BILLING_MODE == 1) {
              $priocredit = $optcredit = 0;
              if (isset($jkp["jak_priority"]) && is_numeric($jkp["jak_priority"])) {
                $priocredit = $jakdb->get($jaktable7, "credits", ["id" => $jkp["jak_priority"]]);
              }

              if (isset($jkp["jak_toption"]) && is_numeric($jkp["jak_toption"])) {
                $optcredit = $jakdb->get($jaktable8, "credits", ["id" => $jkp["jak_toption"]]);
              }

              // Let us collect the department details.
              $depcredit = 0;
              if (isset($HD_SUPPORT_DEPARTMENTS) && is_array($HD_SUPPORT_DEPARTMENTS)) foreach ($HD_SUPPORT_DEPARTMENTS as $v) {
                if ($v["id"] == $_SESSION["depinfo"]) {
                  $depcredit = $v["credits"];
                }         
              }

              $totalc = $depcredit + $priocredit + $optcredit;

              // We need to get the credits
              if ($totalc != 0) {
                // Take some credits away
                $jakdb->update($jaktable5, ["credits[-]" => $totalc], ["id" => $saveclientid[0]]);
                // Credit system control
                $jakdb->insert("taken_credits", ["clientid" => $saveclientid[0], "operatorid" => JAK_USERID, "credits" => $totalc, "#created" => "NOW()"]);

                // Inform the operator that all credits have been used.
                if (($client_save["credits"] - $totalc) < 0) {
                  $_SESSION["errormsg"] = sprintf($jkl['hd227'], $client_save["name"], $client_save["credits"]);
                } 
              }
            // We run the membership based system
            } elseif (JAK_BILLING_MODE == 2 && strtotime($client_save["paid_until"]) < time()) {
              $_SESSION["errormsg"] = sprintf($jkl['hd228'], $client_save["name"], $client_save["paid_until"]);
            }

            // all has been stored let's send the email if whish so
            if (isset($jkp["inform-client"]) && !empty($jkp["inform-client"])) {
              // Finally we inform the customer about the new ticket

              // Dashboard URL
              $ticketurl = str_replace(JAK_OPERATOR_LOC.'/', '', JAK_rewrite::jakParseurl(JAK_SUPPORT_URL, 't', $lastid, JAK_rewrite::jakCleanurl($subjectf)));

              // Let's check if we have an imap
              $answeremail = $ticktext = '';
              $check_imap = $jakdb->get($jaktable7, "emailanswer", ["depid" => $_SESSION["depinfo"]]);
              if ($check_imap) $answeremail = $check_imap;

              // Get the ticket answer template
              if (!empty($HD_ANSWERS) && is_array($HD_ANSWERS)) foreach ($HD_ANSWERS as $v) {
      
                if ($v["msgtype"] == 20 && $v["lang"] == JAK_LANG) {

                  $phold = array('{url}', '{title}', '{cemail}', '{cname}', '{credits}', '{paid_until}', '{ticket}', '{subject}', '{ticketurl}', '{email}');
                  $replace   = array(BASE_URL_ORIG, JAK_TITLE, $client_save['email'], $client_save['name'], $client_save['credits'], $client_save['paid_until'], '#'.$lastid, $subjectf, $ticketurl, $answeremail);
                  $ticktext = str_replace($phold, $replace, $v["message"]);
                  break;
                  
                }
                
              }

              if (!empty($ticktext)) {

                $msgcopy = "";
                  if (JAK_TICKET_FORMAT == 1) {
                  $msgcopy = '<p>--------------------------</p><p><strong>'.date(JAK_DATEFORMAT.JAK_TIMEFORMAT, time()).'</strong></p><div>'.replace_urls_emails($contentf, BASE_URL_ORIG, JAK_FILES_DIRECTORY).'</div><p>--------------------------</p>';
                }
              
                $ticktext = '<p style="color:#c1c1c1;">-------------## Do Not Remove ##-------------</p>'.$ticktext.$msgcopy;

                // Get the email template
                $nlhtml = file_get_contents(APP_PATH.'template/'.JAK_FRONT_TEMPLATE.'/email/index.html');
              
                // Change fake vars into real ones.
                $cssAtt = array('{emailcontent}', '{weburl}', '{title}');
                $cssUrl   = array($ticktext, BASE_URL_ORIG, JAK_TITLE);
                $nlcontent = str_replace($cssAtt, $cssUrl, $nlhtml);
              
                $body = str_ireplace("[\]", "", $nlcontent);

                $mail = new PHPMailer(); // defaults to using php "mail()" or optional SMTP

                if (JAK_SMTP_MAIL) {
                  $mail->IsSMTP(); // telling the class to use SMTP
                  $mail->Host = JAK_SMTPHOST;
                  $mail->SMTPAuth = (JAK_SMTP_AUTH ? true : false); // enable SMTP authentication
                  $mail->SMTPSecure = JAK_SMTP_PREFIX; // sets the prefix to the server
                  $mail->SMTPAutoTLS = false;
                  $mail->SMTPKeepAlive = (JAK_SMTP_ALIVE ? true : false); // SMTP connection will not close after each email sent
                  $mail->Port = JAK_SMTPPORT; // set the SMTP port for the GMAIL server
                  $mail->Username = JAK_SMTPUSERNAME; // SMTP account username
                  $mail->Password = JAK_SMTPPASSWORD; // SMTP account password
                }

                // Finally send the email
                $mail->SetFrom(JAK_EMAIL);
                $mail->addAddress($client_save["email"]);
                $mail->Subject = JAK_TITLE.' - RE:'.$subjectf;
                $mail->MsgHTML($body);

                if ($mail->Send()) $_SESSION["infomsg"] = $jkl['hd134'];

              }
            }

            unset($_SESSION["userinfo"]);
            unset($_SESSION["depinfo"]);

            $_SESSION["successmsg"] = $jkl['g14'];
            jak_redirect(JAK_rewrite::jakParseurl('support', 'read', $lastid));
        }
    
      // Output the errors
      } else {
        $errors = $errors;
      }
    
    }

    // Title and Description
    $SECTION_TITLE = $jkl["hd193"];
    $SECTION_DESC = "";

    // Get all clients
    $CLIENTS_ALL = $jakdb->select($jaktable5, ["id", "support_dep", "name", "email"], ["access" => 1, "ORDER" => ["name" => "ASC"]]);
    // Get the department for the selected client
    if (isset($_SESSION["userinfo"]) && !empty($_SESSION["userinfo"])) {
      $getdep = explode(":#:", $_SESSION["userinfo"]);
      if ($getdep[1] == 0) {
        $DEPARTMENTS_ALL = $jakdb->select($jaktable1, ["id", "title"], ["ORDER" => ["dorder" => "ASC"]]);
      } else {
        $DEPARTMENTS_ALL = $jakdb->select($jaktable1, ["id", "title"], ["id" => [$getdep[1]], "ORDER" => ["dorder" => "ASC"]]);
      }
    }

    if (isset($_SESSION["userinfo"]) && isset($_SESSION["depinfo"])) {

      // Now we get all the informations we need
      $getdep = explode(":#:", $_SESSION["userinfo"]);
      $clientid = $getdep[0];

      $JAK_CLIENT_DATA = $jakdb->get($jaktable5, ["id", "name", "email"], ["id" => $clientid]);
      $JAK_DEP_DATA = $jakdb->get($jaktable1, ["id", "title", "email"], ["id" => $_SESSION["depinfo"]]);

      // Get all operators
      $OPERATOR_ALL = $jakdb->select($jaktable6, ["id", "name", "email"], ["OR #andclause" => ["AND #the first condition" => ["id" => [JAK_SUPERADMIN]], "AND #the second condition" => ["permissions[~]" => "support", "support_dep" => [0, $JAK_DEP_DATA["id"]], "access" => 1]], "ORDER" => ["name" => "ASC"]]);

      // Get all priorities
      $PRIORITY_ALL = $jakdb->select($jaktable3, "*", ["depid" => [0, $JAK_DEP_DATA["id"]]]);
      // Get all options
      $TOPTIONS_ALL = $jakdb->select($jaktable8, "*", ["depid" => [0, $JAK_DEP_DATA["id"]]]);

      // Get the custom fields if any
      $custom_fields = jak_get_custom_fields($jkp, 2, $JAK_DEP_DATA["id"], $jakuser->getVar("language"), false, true, false, false);

      // Get the standard support responses
      $JAK_RESPONSE_DATA = "";
      if (isset($HD_RESPONSEST) && is_array($HD_RESPONSEST)) {

        $JAK_RESPONSE_DATA .= '<option value="0">'.$jkl["g7"].'</option>';
          
        // get the responses from the file specific for this client
        foreach($HD_RESPONSEST as $r) {
          
          if ($r["depid"] == 0 || $r["depid"] == $JAK_DEP_DATA["id"]) {
          
            $phold = array("%operator%","%client%","%email%");
            $replace   = array($jakuser->getVar("name"), $JAK_CLIENT_DATA["name"], JAK_EMAIL);
            $message = str_replace($phold, $replace, $r["message"]);
              
            $JAK_RESPONSE_DATA .= '<option value="'.base64_encode(nl2br(replace_urls(htmlentities($message)))).'">'.$r["title"].'</option>';
              
          }
        }
      }
    }

    // Include the CSS file for the header
    $css_file_header = BASE_URL.'css/selectlive.css';

    // Include the javascript file for results
    $js_file_footer = 'js_newticket.php';

    // Load the template
    $template = 'newticket.php';

  break;
  case 'read':
    // Check if the user exists
    if (is_numeric($page2) && jak_row_exist($page2,$jaktable)) {

      // Get the ticket data first
      $JAK_FORM_DATA = $jakdb->get($jaktable, ["[>]".$jaktable1 => ["depid" => "id"], "[>]".$jaktable5 => ["clientid" => "id"]], ["support_tickets.id", "support_tickets.depid", "support_tickets.subject", "support_tickets.content", "support_tickets.clientid", "support_tickets.ip", "support_tickets.referrer", "support_tickets.notes", "support_tickets.private", "support_tickets.status", "support_tickets.attachments", "support_tickets.initiated", "support_tickets.ended", "support_tickets.updated", "support_tickets.priorityid", "support_tickets.toptionid", "support_departments.title", "clients.name", "clients.email", "clients.support_dep", "clients.credits", "clients.paid_until"], ["support_tickets.id" => $page2]);
    
      if ($_SERVER['REQUEST_METHOD'] == 'POST') {
        $jkp = $_POST;

        // Only store department and option updates
        if (isset($jkp['store-dep']) && $jkp['store-dep'] == 1) {
            
            // We save the new data
            $jakdb->update($jaktable, ["depid" => $jkp['jak_depid'], "priorityid" => $jkp['jak_priority'], "toptionid" => $jkp['jak_toption']], ["id" => $page2]);
            
            if (JAK_BILLING_MODE == 1 && $JAK_FORM_DATA["clientid"] != 0) {

              // Check if we have a change in the departmant
              if ($jkp['jak_depid'] != $jkp['olddep']) {
                if (isset($HD_SUPPORT_DEPARTMENTS) && is_array($HD_SUPPORT_DEPARTMENTS)) foreach ($HD_SUPPORT_DEPARTMENTS as $v) {
                  if ($v["id"] == $jkp['olddep']) {
                    $oldcredits = $v["credits"];
                  }         
                }
                if (isset($HD_SUPPORT_DEPARTMENTS) && is_array($HD_SUPPORT_DEPARTMENTS)) foreach ($HD_SUPPORT_DEPARTMENTS as $v) {
                  if ($v["id"] == $jkp['jak_depid']) {
                    $newcredits = $v["credits"];
                  }         
                }

                if ($newcredits > $oldcredits) {
                  $newc = $newcredits - $oldcredits;
                  $jakdb->update($jaktable5, ["credits[-]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);

                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "#created" => "NOW()"]);

                } elseif ($newcredits < $oldcredits) {
                  $newc = $oldcredits - $newcredits;
                  $jakdb->update($jaktable5, ["credits[+]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "taken" => 0, "#created" => "NOW()"]);
                }
              }

              // Check if we have a change in the priority
              if ($jkp['jak_priority'] != $jkp['oldpriority']) {
                $oldcredits = $jakdb->get($jaktable3, "credits", ["id" => $jkp['oldpriority']]);
                $newcredits = $jakdb->get($jaktable3, "credits", ["id" => $jkp['jak_priority']]);

                if ($newcredits > $oldcredits) {
                  $newc = $newcredits - $oldcredits;
                  $jakdb->update($jaktable5, ["credits[-]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "#created" => "NOW()"]);
                } elseif ($newcredits < $oldcredits) {
                  $newc = $oldcredits - $newcredits;
                  $jakdb->update($jaktable5, ["credits[+]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "taken" => 0, "#created" => "NOW()"]);
                }
              }

              // Check if we have a change in the option
              if ($jkp['jak_toption'] != $jkp['oldtoption']) {
                $oldcredits = $jakdb->get($jaktable8, "credits", ["id" => $jkp['oldtoption']]);
                $newcredits = $jakdb->get($jaktable8, "credits", ["id" => $jkp['jak_toption']]);

                if ($newcredits > $oldcredits) {
                  $newc = $newcredits - $oldcredits;
                  $jakdb->update($jaktable5, ["credits[-]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "#created" => "NOW()"]);
                } elseif ($newcredits < $oldcredits) {
                  $newc = $oldcredits - $newcredits;
                  $jakdb->update($jaktable5, ["credits[+]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "taken" => 0, "#created" => "NOW()"]);
                }
              }

              // Update the private status
              $jakdb->update($jaktable, ["private" => $jkp['jak_private']], ["id" => $page2]);

            }

            $_SESSION["successmsg"] = $jkl['g14'];
            jak_redirect($_SESSION['LCRedirect']);
        }

        // Only store notes and go ahead
        if (isset($jkp['store-notes']) && $jkp['store-notes'] == 1) {
            $savenotes = filter_var($jkp['notes'], FILTER_SANITIZE_STRING);
            $jakdb->update($jaktable, ["notes" => $savenotes], ["id" => $page2]);
            $_SESSION["successmsg"] = $jkl['g14'];
            jak_redirect($_SESSION['LCRedirect']);
        }

        // Only store custom fields and go ahead
        if (isset($jkp['store-fields']) && $jkp['store-fields'] == 1) {
            // And we complete the custom fields
            $formfields = $jakdb->select('customfields', "val_slug", ["fieldlocation" => 2]);
            if (isset($formfields) && !empty($formfields)) {
              foreach ($formfields as $v) {
                if (isset($jkp[$v]) && is_array($jkp[$v])) {
                  $joinval = join(',', $jkp[$v]);
                  $jakdb->update($jaktable, [$v => $joinval], ["id" => $page2]);
                } else {
                  $jakdb->update($jaktable, [$v => $jkp[$v]], ["id" => $page2]);
                }
              }
            }

            $_SESSION["successmsg"] = $jkl['g14'];
            jak_redirect($_SESSION['LCRedirect']);
        }

        // We edit some content
        if (isset($jkp['edit-content']) && $jkp['edit-content'] == $page2 && $jakdb->has($jaktable, ["id" => $page2])) {
          $subjectf = filter_var($jkp['subject'], FILTER_SANITIZE_STRING);
          $contentf = jak_clean_safe_userpost($jkp['content']);
          $jakdb->update($jaktable, ["subject" => $subjectf, "content" => $contentf], ["id" => $page2]);
          $_SESSION["successmsg"] = $jkl['g14'];
          jak_redirect(JAK_rewrite::jakParseurl('support', 'read', $page2));          
        }

        // We edit some answers
        if (isset($jkp['edit-answer']) && $jkp['edit-answer'] == $page3 && $jakdb->has($jaktable4, ["AND" => ["id" => $page3, "ticketid" => $page2]])) {
          $contentf = jak_clean_safe_userpost($jkp['content']);
          $jakdb->update($jaktable4, ["content" => $contentf], ["id" => $page3]);
          $_SESSION["successmsg"] = $jkl['g14'];
          jak_redirect(JAK_rewrite::jakParseurl('support', 'read', $page2));          
        }
        
        if (empty($jkp['content'])) { 
          $errors['e1'] = $jkl['e1'];
        }
        
        if (count($errors) == 0) {

          // Filter the content
          $contentf = jak_clean_safe_userpost($jkp['content']);

          $result = $jakdb->insert($jaktable4, ["ticketid" => $page2,
            "operatorid" => JAK_USERID,
            "content" => $contentf,
            "#lastedit" => "NOW()",
            "#sent" => "NOW()"]);
    
        if (!$result) {
            $_SESSION["infomsg"] = $jkl['i'];
            jak_redirect($_SESSION['LCRedirect']);
        } else {

            $savenotes = filter_var($jkp['notes'], FILTER_SANITIZE_STRING);
            // Update the ticket
            $jakdb->update($jaktable, ["depid" => $jkp['jak_depid'], "priorityid" => $jkp['jak_priority'], "toptionid" => $jkp['jak_toption'], "status" => 2, "updated" => time(), "notes" => $savenotes, "private" => $jkp['jak_private']], ["id" => $page2]);

            if (JAK_BILLING_MODE == 1 && $JAK_FORM_DATA["clientid"] != 0) {

              // Check if we have a change in the departmant
              if ($jkp['jak_depid'] != $jkp['olddep']) {
                if (isset($HD_SUPPORT_DEPARTMENTS) && is_array($HD_SUPPORT_DEPARTMENTS)) foreach ($HD_SUPPORT_DEPARTMENTS as $v) {
                  if ($v["id"] == $jkp['olddep']) {
                    $oldcredits = $v["credits"];
                  }         
                }
                if (isset($HD_SUPPORT_DEPARTMENTS) && is_array($HD_SUPPORT_DEPARTMENTS)) foreach ($HD_SUPPORT_DEPARTMENTS as $v) {
                  if ($v["id"] == $jkp['jak_depid']) {
                    $newcredits = $v["credits"];
                  }         
                }

                if ($newcredits > $oldcredits) {
                  $newc = $newcredits - $oldcredits;
                  $jakdb->update($jaktable5, ["credits[-]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "#created" => "NOW()"]);
                } elseif ($newcredits < $oldcredits) {
                  $newc = $oldcredits - $newcredits;
                  $jakdb->update($jaktable5, ["credits[+]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "taken" => 0, "#created" => "NOW()"]);
                }
              }

              // Check if we have a change in the priority
              if ($jkp['jak_priority'] != $jkp['oldpriority']) {
                $oldcredits = $jakdb->get($jaktable3, "credits", ["id" => $jkp['oldpriority']]);
                $newcredits = $jakdb->get($jaktable3, "credits", ["id" => $jkp['jak_priority']]);

                if ($newcredits > $oldcredits) {
                  $newc = $newcredits - $oldcredits;
                  $jakdb->update($jaktable5, ["credits[-]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "#created" => "NOW()"]);
                } elseif ($newcredits < $oldcredits) {
                  $newc = $oldcredits - $newcredits;
                  $jakdb->update($jaktable5, ["credits[+]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "taken" => 0, "#created" => "NOW()"]);
                }
              }

              // Check if we have a change in the option
              if ($jkp['jak_toption'] != $jkp['oldtoption']) {
                $oldcredits = $jakdb->get($jaktable8, "credits", ["id" => $jkp['oldtoption']]);
                $newcredits = $jakdb->get($jaktable8, "credits", ["id" => $jkp['jak_toption']]);

                if ($newcredits > $oldcredits) {
                  $newc = $newcredits - $oldcredits;
                  $jakdb->update($jaktable5, ["credits[-]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "#created" => "NOW()"]);
                } elseif ($newcredits < $oldcredits) {
                  $newc = $oldcredits - $newcredits;
                  $jakdb->update($jaktable5, ["credits[+]" => $newc], ["id" => $JAK_FORM_DATA["clientid"]]);
                  // Credit system control
                  $jakdb->insert("taken_credits", ["clientid" => $JAK_FORM_DATA["clientid"], "operatorid" => JAK_USERID, "credits" => $newc, "taken" => 0, "#created" => "NOW()"]);
                }
              }

            }

            // And we complete the custom fields
            $formfields = $jakdb->select('customfields', "val_slug", ["fieldlocation" => 2]);
            if (isset($formfields) && !empty($formfields)) {
              foreach ($formfields as $v) {
                if (isset($jkp[$v]) && is_array($jkp[$v])) {
                  $joinval = join(',', $jkp[$v]);
                  $jakdb->update($jaktable, [$v => filter_var($joinval, FILTER_SANITIZE_STRING)], ["id" => $page2]);
                } else {
                  $jakdb->update($jaktable, [$v => filter_var($jkp[$v], FILTER_SANITIZE_STRING)], ["id" => $page2]);
                }
              }
            }

            // Finally we inform the customer about the answer

            // Dashboard URL
            $ticketurl = str_replace(JAK_OPERATOR_LOC.'/', '', JAK_rewrite::jakParseurl(JAK_SUPPORT_URL, 't', $page2, JAK_rewrite::jakCleanurl($JAK_FORM_DATA["subject"])));

            // Let's check if we have an imap
            $answeremail = $ticktext = '';
            $check_imap = $jakdb->get($jaktable7, "emailanswer", ["depid" => $JAK_FORM_DATA["depid"]]);
            if ($check_imap) $answeremail = $check_imap;

            // Get the ticket answer template
            if (!empty($HD_ANSWERS) && is_array($HD_ANSWERS)) foreach ($HD_ANSWERS as $v) {
    
              if ($v["msgtype"] == 21 && $v["lang"] == JAK_LANG) {

                $phold = array('{url}', '{title}', '{cemail}', '{cname}', '{credits}', '{paid_until}', '{ticket}', '{subject}', '{ticketurl}', '{email}');
                $replace   = array(BASE_URL_ORIG, JAK_TITLE, $JAK_FORM_DATA['email'], $JAK_FORM_DATA['name'], $JAK_FORM_DATA['credits'], $JAK_FORM_DATA['paid_until'], '#'.$page2, $JAK_FORM_DATA['subject'], $ticketurl, $answeremail);
                $ticktext = str_replace($phold, $replace, $v["message"]);
                break;
                
              }
              
            }

            if (!empty($ticktext)) {

              $msgcopy = "";
                if (JAK_TICKET_FORMAT == 1) {
                $msgcopy = '<p>--------------------------</p><p><strong>'.date(JAK_DATEFORMAT.JAK_TIMEFORMAT, time()).'</strong></p><div>'.replace_urls_emails($contentf, BASE_URL_ORIG, JAK_FILES_DIRECTORY).'</div><p>--------------------------</p>';
              }
            
              $ticktext = '<p style="color:#c1c1c1;">-------------## Do Not Remove ##-------------</p>'.$ticktext.$msgcopy;

              // Get the email template
              $nlhtml = file_get_contents(APP_PATH.'template/'.JAK_FRONT_TEMPLATE.'/email/index.html');
            
              // Change fake vars into real ones.
              $cssAtt = array('{emailcontent}', '{weburl}', '{title}');
              $cssUrl   = array($ticktext, BASE_URL_ORIG, JAK_TITLE);
              $nlcontent = str_replace($cssAtt, $cssUrl, $nlhtml);
            
              $body = str_ireplace("[\]", "", $nlcontent);

              $mail = new PHPMailer(); // defaults to using php "mail()" or optional SMTP

              if (JAK_SMTP_MAIL) {
                $mail->IsSMTP(); // telling the class to use SMTP
                $mail->Host = JAK_SMTPHOST;
                $mail->SMTPAuth = (JAK_SMTP_AUTH ? true : false); // enable SMTP authentication
                $mail->SMTPSecure = JAK_SMTP_PREFIX; // sets the prefix to the server
                $mail->SMTPAutoTLS = false;
                $mail->SMTPKeepAlive = (JAK_SMTP_ALIVE ? true : false); // SMTP connection will not close after each email sent
                $mail->Port = JAK_SMTPPORT; // set the SMTP port for the GMAIL server
                $mail->Username = JAK_SMTPUSERNAME; // SMTP account username
                $mail->Password = JAK_SMTPPASSWORD; // SMTP account password
              }

              // Finally send the email
              $mail->SetFrom(JAK_EMAIL);
              $mail->addAddress($JAK_FORM_DATA['email']);
              $mail->Subject = JAK_TITLE.' - RE:'.$JAK_FORM_DATA['subject'];
              $mail->MsgHTML($body);

              if ($mail->Send()) $_SESSION["infomsg"] = $jkl['hd134'];

            }

            $_SESSION["successmsg"] = $jkl['g14'];
            jak_redirect($_SESSION['LCRedirect']);
        }
    
      // Output the errors
      } else {
      
          $errors = $errors;
      }
    
    }
      // Title and Description
      $SECTION_TITLE = $jkl["hd176"];
      $SECTION_DESC = "";

      if ($JAK_FORM_DATA["support_dep"] == 0) {
          $DEPARTMENTS_ALL = $jakdb->select($jaktable1, ["id", "title"], ["ORDER" => ["dorder" => "ASC"]]);
      } else {
          $DEPARTMENTS_ALL = $jakdb->select($jaktable1, ["id", "title"], ["id" => [$JAK_FORM_DATA["support_dep"]], "ORDER" => ["dorder" => "ASC"]]);
      }

      // Get all responses
      $PRIORITY_ALL = $jakdb->select($jaktable3, "*", ["depid" => [0, $JAK_FORM_DATA["depid"]]]);
      // Get all responses
      $TOPTIONS_ALL = $jakdb->select($jaktable8, "*", ["depid" => [0, $JAK_FORM_DATA["depid"]]]);

      // Get the ticket Answers
      $JAK_ANSWER_DATA = $jakdb->select($jaktable4, ["[>]".$jaktable6 => ["operatorid" => "id"], "[>]".$jaktable5 => ["clientid" => "id"]], ["ticket_answers.id", "ticket_answers.content", "ticket_answers.lastedit", "ticket_answers.sent", "user.id(oid)", "user.name(oname)", "clients.id(cid)", "clients.name(cname)"], ["ticket_answers.ticketid" => $page2, "ORDER" => ["ticket_answers.sent" => "DESC"]]);

      // Get the standard support responses
      $JAK_RESPONSE_DATA = "";
      if (isset($HD_RESPONSEST) && is_array($HD_RESPONSEST)) {

        $JAK_RESPONSE_DATA .= '<option value="0">'.$jkl["g7"].'</option>';
        
        // get the responses from the file specific for this client
        foreach($HD_RESPONSEST as $r) {
        
          if ($r["depid"] == 0 || $r["depid"] == $JAK_FORM_DATA["depid"]) {
        
            $phold = array("%operator%","%client%","%email%");
            $replace   = array($jakuser->getVar("name"), $JAK_FORM_DATA["name"], JAK_EMAIL);
            $message = str_replace($phold, $replace, $r["message"]);
            
            $JAK_RESPONSE_DATA .= '<option value="'.base64_encode(nl2br(replace_urls(htmlentities($message)))).'">'.$r["title"].'</option>';
            
          }
        }
      }

      // Get the custom fields if any
      $custom_fields = jak_get_custom_fields($JAK_FORM_DATA, 2, $JAK_FORM_DATA["depid"], $jakuser->getVar("language"), false, true, false, false);

      // Get the attachments if any
      if ($JAK_FORM_DATA["attachments"] != 0) {
        $JAK_TICKET_FILES = jak_get_files(APP_PATH.JAK_FILES_DIRECTORY.'/support/'.$page2);
      }

      // We edit some content
      $editcont = 0;
      if (isset($page3) && $page3 == 'edit') {
        $JAK_EDIT_CONTENT = $jakdb->get($jaktable, ["subject", "content"], ["id" => $page2]);
        $editcont = $page2;
      }

      // We edit some answer
      $editid = 0;
      if (isset($page3) && is_numeric($page3) && $jakdb->has($jaktable4, ["AND" => ["id" => $page3, "ticketid" => $page2]])) {
        $JAK_EDIT_ANSWER = $jakdb->get($jaktable4, "content", ["id" => $page3]);
        $editid = $page3;
      }

      // Include the CSS file for the header
      $css_file_header = BASE_URL_ORIG.'css/dropzone.css';

      // Include the javascript file for results
      $js_file_footer = 'js_ticket.php';

      // Load the template
      $template = 'readticket.php';
    
    } else {
        $_SESSION["errormsg"] = $jkl['i3'];
        jak_redirect($_SESSION['LCRedirect']);
    }
  break;
  case 'rating':
    // Check if the file can be deleted
    if (isset($page2) && is_numeric($page2) && $jakdb->has($jaktable, ["id" => $page2])) {

      $rowt = $jakdb->get($jaktable, ["subject"], ["id" => $page2]);
      $row = $jakdb->get("ticket_rating", ["clientid", "name", "email", "vote", "comment", "support_time"], ["ticketid" => $page2]);

      // Call the template
      $template = 'ticketrating.php';

    } else {
        $_SESSION["errormsg"] = $jkl['i3'];
        jak_redirect(JAK_rewrite::jakParseurl('support'));
    }
  break;
  case 'deletef':
    # code...
    // Check if the file can be deleted
    if (is_numeric($page2) && !empty($page3)) {
      
      // Now let us delete the file
      $filedel = APP_PATH.JAK_FILES_DIRECTORY.'/support/'.$page2.'/'.$page3;
      if (file_exists($filedel)) {
        unlink($filedel);
      }

      // Counter - 1
      $jakdb->update($jaktable, ["attachments[-]" => 1], ["id" => $page2]);
      
        $_SESSION["successmsg"] = $jkl['g14'];
        jak_redirect($_SESSION['LCRedirect']);
        
    } else {
        $_SESSION["errormsg"] = $jkl['i3'];
        jak_redirect($_SESSION['LCRedirect']);
    }
  break;
  case 'status':
    // Check if the ticket exists
    if (is_numeric($page2) && is_numeric($page3) && jak_row_exist($page2,$jaktable)) {

      // Now check how many languages are installed and do the dirty work
      $result = $jakdb->update($jaktable, ["status" => $page3, "ended" => 0], ["id" => $page2]);

      // Ticket is closed set an ending time
      if ($page3 == 3 || $page3 == 4) {
        $jakdb->update($jaktable, ["ended" => time()], ["id" => $page2]);

        // Get the ticket data first
        $ticketdata = $jakdb->get($jaktable, ["[>]clients" => ["clientid" => "id"]], ["support_tickets.id", "support_tickets.depid", "support_tickets.name", "support_tickets.email", "support_tickets.subject", "support_tickets.initiated", "clients.credits", "clients.paid_until"], ["support_tickets.id" => $page2]);

        // Send email to customers if set so.
        if (JAK_TICKET_CLOSE_R == 1) {

          // Dashboard URL
          $ticketurl = str_replace(JAK_OPERATOR_LOC.'/', '', JAK_rewrite::jakParseurl(JAK_SUPPORT_URL, 't', $page2, JAK_rewrite::jakCleanurl($ticketdata["subject"])));

          // Let's check if we have an imap
          $answeremail = $ticktext = '';
          $check_imap = $jakdb->get($jaktable7, "emailanswer", ["depid" => $ticketdata["depid"]]);
          if ($check_imap) $answeremail = $check_imap;

          // Get the ticket answer template
          if (!empty($HD_ANSWERS) && is_array($HD_ANSWERS)) foreach ($HD_ANSWERS as $v) {
    
            if ($v["msgtype"] == 23 && $v["lang"] == JAK_LANG) {

              $phold = array('{url}', '{title}', '{cemail}', '{cname}', '{credits}', '{paid_until}', '{ticket}', '{subject}', '{ticketurl}', '{email}');
              $replace   = array(BASE_URL_ORIG, JAK_TITLE, $ticketdata['email'], $ticketdata['name'], $ticketdata['credits'], $ticketdata['paid_until'], '#'.$page3, $ticketdata['subject'], $ticketurl, $answeremail);
              $ticktext = str_replace($phold, $replace, $v["message"]);
              break;
                
            }
              
          }

          // Get the email template
          if (!empty($ticktext)) {
              $nlhtml = file_get_contents(APP_PATH.'template/'.JAK_FRONT_TEMPLATE.'/email/index.html');
            
              // Change fake vars into real ones.
              $cssAtt = array('{emailcontent}', '{weburl}', '{title}');
              $cssUrl   = array($ticktext, BASE_URL_ORIG, JAK_TITLE);
              $nlcontent = str_replace($cssAtt, $cssUrl, $nlhtml);
            
              $body = str_ireplace("[\]", "", $nlcontent);

              $mail = new PHPMailer(); // defaults to using php "mail()" or optional SMTP

              if (JAK_SMTP_MAIL) {
                $mail->IsSMTP(); // telling the class to use SMTP
                $mail->Host = JAK_SMTPHOST;
                $mail->SMTPAuth = (JAK_SMTP_AUTH ? true : false); // enable SMTP authentication
                $mail->SMTPSecure = JAK_SMTP_PREFIX; // sets the prefix to the server
                $mail->SMTPAutoTLS = false;
                $mail->SMTPKeepAlive = (JAK_SMTP_ALIVE ? true : false); // SMTP connection will not close after each email sent
                $mail->Port = JAK_SMTPPORT; // set the SMTP port for the GMAIL server
                $mail->Username = JAK_SMTPUSERNAME; // SMTP account username
                $mail->Password = JAK_SMTPPASSWORD; // SMTP account password
              }

              // Finally send the email
              $mail->SetFrom(JAK_EMAIL);
              $mail->addAddress($ticketdata['email']);
              $mail->Subject = JAK_TITLE.' - '.sprintf($jkl['hd192'], $ticketdata['subject']);
              $mail->MsgHTML($body);

              if ($mail->Send()) $_SESSION["infomsg"] = $jkl['hd134'];
          }

        } // end sending closed message

        // Send rating to customer when ticket is closed forever
        if ($page3 == 4) {

          // Dashboard URL
          $ticketratingurl = str_replace(JAK_OPERATOR_LOC.'/', '', JAK_rewrite::jakParseurl(JAK_CLIENT_URL, 'rt', $ticketdata["id"], $ticketdata["initiated"]));

          // Let's check if we have an imap
          $answeremail = $ticktextr = '';
          $check_imap = $jakdb->get($jaktable7, "emailanswer", ["depid" => $ticketdata["depid"]]);
          if ($check_imap) $answeremail = $check_imap;

          // Get the ticket answer template
          if (!empty($HD_ANSWERS) && is_array($HD_ANSWERS)) foreach ($HD_ANSWERS as $v) {
          
              if ($v["msgtype"] == 25 && $v["lang"] == JAK_LANG) {

                  $pholdr = array('{url}', '{title}', '{cemail}', '{cname}', '{credits}', '{paid_until}', '{ticket}', '{subject}', '{ticketurl}', '{email}');
                  $replacer   = array(str_replace(JAK_OPERATOR_LOC.'/', '', BASE_URL), JAK_TITLE, $ticketdata['email'], $ticketdata['name'], $ticketdata['credits'], $ticketdata['paid_until'], '#'.$ticketdata["id"], $ticketdata['subject'], $ticketratingurl, $answeremail);
                  $ticktextr = str_replace($pholdr, $replacer, $v["message"]);
                  break;
                      
              }
                    
          }

          if (!empty($ticktextr)) {

              // Get the email template
              $nlhtml = file_get_contents(APP_PATH.'template/'.JAK_FRONT_TEMPLATE.'/email/index.html');
                  
              // Change fake vars into real ones.
              $cssAtt = array('{emailcontent}', '{weburl}', '{title}');
              $cssUrl   = array($ticktextr, str_replace(JAK_OPERATOR_LOC.'/', '', BASE_URL), JAK_TITLE);
              $nlcontent = str_replace($cssAtt, $cssUrl, $nlhtml);
                  
              $body = str_ireplace("[\]", "", $nlcontent);

              $mail = new PHPMailer(); // defaults to using php "mail()" or optional SMTP

              if (JAK_SMTP_MAIL) {
                  $mail->IsSMTP(); // telling the class to use SMTP
                  $mail->Host = JAK_SMTPHOST;
                  $mail->SMTPAuth = (JAK_SMTP_AUTH ? true : false); // enable SMTP authentication
                  $mail->SMTPSecure = JAK_SMTP_PREFIX; // sets the prefix to the server
                  $mail->SMTPAutoTLS = false;
                  $mail->SMTPKeepAlive = (JAK_SMTP_ALIVE ? true : false); // SMTP connection will not close after each email sent
                  $mail->Port = JAK_SMTPPORT; // set the SMTP port for the GMAIL server
                  $mail->Username = JAK_SMTPUSERNAME; // SMTP account username
                  $mail->Password = JAK_SMTPPASSWORD; // SMTP account password
              }

              // Finally send the email
              $mail->SetFrom(JAK_EMAIL);
              $mail->addAddress($ticketdata['email']);
              $mail->Subject = JAK_TITLE.' - '.$jkl['g85'].': '.$ticketdata['subject'];
              $mail->MsgHTML($body);

              $mail->Send();

              // Now we update the ticket table
              $jakdb->update($jaktable, ["reminder" => 2], ["id" => $ticketdata['id']]);

          }

        }

      }
    
      if (!$result) {
          $_SESSION["infomsg"] = $jkl['i'];
          jak_redirect($_SESSION['LCRedirect']);
      } else {
        
          $_SESSION["successmsg"] = $jkl['g14'];
          jak_redirect($_SESSION['LCRedirect']);
      }

    } else {
      $_SESSION["errormsg"] = $jkl['i3'];
      jak_redirect($_SESSION['LCRedirect']);      
    }
  break;
  default:

    // if (isset($page1) && !is_numeric($page1) && !empty($page1)) jak_redirect(JAK_rewrite::jakParseurl('support'));

    // Let's go on with the script
    if ($_SERVER['REQUEST_METHOD'] == 'POST') {
        $jkp = $_POST;

        if (isset($jkp['action']) && $jkp['action'] == "depid") {
          if (isset($jkp['jak_depid']) && is_numeric($jkp['jak_depid']) && $jkp['jak_depid'] != 0) {
            if ($jakuser->getVar("support_dep") == 0 || in_array($jkp['jak_depid'], explode(",", $jakuser->getVar("support_dep")))) {
              $_SESSION["sortdepid"] = $jkp['jak_depid'];
              jak_redirect(JAK_rewrite::jakParseurl('support', $jkp['jak_depid']));
            }
          }
          unset($_SESSION["sortdepid"]);
          jak_redirect(JAK_rewrite::jakParseurl('support'));
        }
        
        if (isset($jkp['action']) && $jkp['action'] == "delete") {

          if (!JAK_USERID || !JAK_SUPERADMINACCESS) jak_redirect(BASE_URL);
        
          if (isset($jkp['jak_delete_tickets'])) {
            
            $delartic = $jkp['jak_delete_tickets'];
      
              for ($i = 0; $i < count($delartic); $i++) {
                  $delart = $delartic[$i];

                  // Delete the ticket
                  $jakdb->delete($jaktable, ["id" => $delart]);

                  // Delete the answer
                  $jakdb->delete($jaktable4, ["ticketid" => $delart]);

                  // Delete all attachments
                  $targetPath = APP_PATH.JAK_FILES_DIRECTORY.'/support/'.$delart.'/';
                  $removedouble =  str_replace("//","/",$targetPath);
                  foreach(glob($removedouble.'*.*') as $jak_unlink) {
                    // Delete all files
                    @unlink($jak_unlink);    
                  }
                  // Delete the folder
                  @rmdir($targetPath);
                
              }
              
              $_SESSION["successmsg"] = $jkl['g14'];
              jak_redirect($_SESSION['LCRedirect']);
          }
      
          $_SESSION["errormsg"] = $jkl['i3'];
          jak_redirect($_SESSION['LCRedirect']);
        
        }

        if (isset($jkp['action']) && ($jkp['action'] == "status1" || $jkp['action'] == "status2" || $jkp['action'] == "status3")) {

          if (!JAK_USERID || !JAK_SUPERADMINACCESS) jak_redirect(BASE_URL);
        
          if (isset($jkp['jak_delete_tickets'])) {
            
            // Get all selected tickets
            $delartic = $jkp['jak_delete_tickets'];

            // Get the status
            $newstatus = filter_var($jkp['action'], FILTER_SANITIZE_NUMBER_INT);

            // Initiate the php mailer outside the for loop
            $mail = new PHPMailer(); // defaults to using php "mail()" or optional SMTP
      
              for ($i = 0; $i < count($delartic); $i++) {
                $delart = $delartic[$i];
                $jakdb->update($jaktable, ["status" => str_replace("status", "", $newstatus)], ["id" => $delart]);

                // Ticket is closed set an ending time
                if ($newstatus == 3) {
                  $jakdb->update($jaktable, ["ended" => time()], ["id" => $delart]);

                  // Send email to customers if set so.
                  if (JAK_TICKET_CLOSE_R == 1) {

                    // Get the ticket data first
                    $ticketdata = $jakdb->get($jaktable, ["[>]clients" => ["clientid" => "id"]], ["support_tickets.id", "support_tickets.depid", "support_tickets.name", "support_tickets.email", "support_tickets.subject", "clients.credits", "clients.paid_until"], ["support_tickets.id" => $delart]);

                    // Dashboard URL
                    $ticketurl = str_replace(JAK_OPERATOR_LOC.'/', '', JAK_rewrite::jakParseurl(JAK_SUPPORT_URL, 't', $delart, JAK_rewrite::jakCleanurl($ticketdata["subject"])));

                    // Let's check if we have an imap
                    $answeremail = $ticktext = '';
                    $check_imap = $jakdb->get($jaktable7, "emailanswer", ["depid" => $ticketdata["depid"]]);
                    if ($check_imap) $answeremail = $check_imap;

                    // Get the ticket answer template
                    if (!empty($HD_ANSWERS) && is_array($HD_ANSWERS)) foreach ($HD_ANSWERS as $v) {
              
                      if ($v["msgtype"] == 23 && $v["lang"] == JAK_LANG) {

                        $phold = array('{url}', '{title}', '{cemail}', '{cname}', '{credits}', '{paid_until}', '{ticket}', '{subject}', '{ticketurl}', '{email}');
                        $replace   = array(BASE_URL_ORIG, JAK_TITLE, $ticketdata['email'], $ticketdata['name'], $ticketdata['credits'], $ticketdata['paid_until'], '#'.$delart, $ticketdata['subject'], $ticketurl, $answeremail);
                        $ticktext = str_replace($phold, $replace, $v["message"]);
                        break;
                          
                      }
                        
                    }

                    // Get the email template
                    if (!empty($ticktext)) {
                        $nlhtml = file_get_contents(APP_PATH.'template/'.JAK_FRONT_TEMPLATE.'/email/index.html');
                      
                        // Change fake vars into real ones.
                        $cssAtt = array('{emailcontent}', '{weburl}', '{title}');
                        $cssUrl   = array($ticktext, BASE_URL_ORIG, JAK_TITLE);
                        $nlcontent = str_replace($cssAtt, $cssUrl, $nlhtml);
                      
                        $body = str_ireplace("[\]", "", $nlcontent);

                        if (JAK_SMTP_MAIL) {
                          $mail->IsSMTP(); // telling the class to use SMTP
                          $mail->Host = JAK_SMTPHOST;
                          $mail->SMTPAuth = (JAK_SMTP_AUTH ? true : false); // enable SMTP authentication
                          $mail->SMTPSecure = JAK_SMTP_PREFIX; // sets the prefix to the server
                          $mail->SMTPAutoTLS = false;
                          $mail->SMTPKeepAlive = (JAK_SMTP_ALIVE ? true : false); // SMTP connection will not close after each email sent
                          $mail->Port = JAK_SMTPPORT; // set the SMTP port for the GMAIL server
                          $mail->Username = JAK_SMTPUSERNAME; // SMTP account username
                          $mail->Password = JAK_SMTPPASSWORD; // SMTP account password
                        }

                        // Finally send the email
                        $mail->SetFrom(JAK_EMAIL);
                        $mail->addAddress($ticketdata['email']);
                        $mail->Subject = JAK_TITLE.' - '.sprintf($jkl['hd192'], $ticketdata['subject']);
                        $mail->MsgHTML($body);

                        // Send email to customer
                        $mail->Send();
                    }

                  } // end sending closed message
                }
              }
              
              $_SESSION["successmsg"] = $jkl['g14'];
              jak_redirect($_SESSION['LCRedirect']);
          }
      
          $_SESSION["errormsg"] = $jkl['i3'];
          jak_redirect($_SESSION['LCRedirect']);
        
        }   
    }
    
    // Leads
    $totalAll = $totalAllOT = $totalAllWT = $totalAllCT = $total_vote = $total_voted = 0;

    // Get the totals
    $totalAll = $jakdb->count($jaktable);

    // Open Tickets
    $totalAllOT = $jakdb->count($jaktable, ["status" => 1]);
    // Awaiting Reply Tickets
    $totalAllWT = $jakdb->count($jaktable, ["status" => 2]);
    // Closed Tickets
    $totalAllCT = $jakdb->count($jaktable, ["status" => 3]);

    $total_voted = $jakdb->count($jaktable, ["reminder" => 3]);
    $total_vote = $jakdb->sum("ticket_rating", "vote");

    // Get the support departments
    if (count($HD_SUPPORT_DEPARTMENTS) == 1) {
      $dep_filter = false;
    } else {
      if (is_numeric($jakuser->getVar("support_dep")) && $jakuser->getVar("support_dep") != 0) {
        $dep_filter = $jakdb->get("support_departments", ["id", "title"], ["AND" => ["id" => $jakuser->getVar("support_dep"), "active" => 1], "ORDER" => ["dorder" => "ASC"]]);

        $dep_filter = false;
      } elseif (!((boolean)$jakuser->getVar("support_dep")) && $jakuser->getVar("support_dep") != 0) {
        $dep_filter = $jakdb->select("support_departments", ["id", "title"], ["AND" => ["id" => [$jakuser->getVar("support_dep")], "active" => 1], "ORDER" => ["dorder" => "ASC"]]);
      } else {
        $dep_filter = $HD_SUPPORT_DEPARTMENTS;
      }
    }
    
    // Title and Description
    $SECTION_TITLE = $jkl["hd"];
    $SECTION_DESC = "";
    
    // Include the javascript file for results
    $js_file_footer = 'js_support.php';
    
    // Call the template
    $template = 'support.php';
}
?>