<?php

/*===============================================*\
|| ############################################# ||
|| # JAKWEB.CH / Version 3.1.1                 # ||
|| # ----------------------------------------- # ||
|| # Copyright 2017 JAKWEB All Rights Reserved # ||
|| ############################################# ||
\*===============================================*/

// Check if the file is accessed only via index.php if not stop the script from running
if (!defined('JAK_PREVENT_ACCESS')) die('You cannot access this file directly.');

// buffer flush
ob_start();

// We make the chat open
if (isset($page1) && $page1 == 1) $_SESSION["slidestatus"] = "open";

if (isset($_SESSION['jrc_userid']) && isset($_SESSION['convid'])) jak_redirect(JAK_rewrite::jakParseurl('chat', $page1, $page2));

// Get the department
$dep_direct = 1;
if (isset($page3) && is_numeric($page3) && $page3 != 0) {
	foreach ($online_op as $d) {
	    if (in_array($page3, $d)) {
	        $dep_direct = $page3;
	    }
	}
}

// Operator ID if set.
$opdirect = 0;
if (isset($jakwidget['opid']) && is_numeric($jakwidget['opid']) && $jakwidget['opid'] != 0) $opdirect = $jakwidget['opid'];

// Get the PHP GET for quick login
$sendform = false;
if (isset($_SESSION['custom_vars']) && !empty($_SESSION['custom_vars'])) {
	$cvar = explode(":#:", $_SESSION['custom_vars']);
	// We convert the get into $jkp vars
	if (isset($cvar[0]) && !empty($cvar[0])) $jkp['name'] = $_REQUEST["name"] = $cvar[0];
	if (isset($cvar[1]) && !empty($cvar[1])) $jkp['email'] = $_REQUEST["email"] = $cvar[1];
	if (isset($cvar[2]) && !empty($cvar[2])) $jkp['question'] = $_REQUEST["question"] = $cvar[2];
	$sendform = true;
}

// Get the client browser
$ua = new Browser();

if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['start_chat'])) {
		if (!$sendform) $jkp = $_POST;
		
		// Errors in Array
		$errors = array();
		
		if (empty($jkp['message']) || strlen(trim($jkp['message'])) <= 2) {
		    $errors['message'] = $jkl['e2'];
		}
		
		if (!JAK_CLIENTID && JAK_CAPTCHA && !$sendform) {
			$human_captcha = explode(':#:', $_SESSION['jrc_captcha']);
			
			if ($jkp[$human_captcha[0]] == '' || $jkp[$human_captcha[0]] != $human_captcha[1]) {
				$errors['human'] = $jkl['e12'];
			}
		}
				
		if (count($errors) > 0) {
			
			/* Outputtng the error messages */
			if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			
				header('Cache-Control: no-cache');
				die('{"status":0, "errors":'.json_encode($errors).'}');
				
			} else {
			
				$errors = $errors;
			}
			
		} else {
			
			// Country stuff
			$countryName = 'Disabled';
			$countryAbbrev = 'xx';
			$city = 'Disabled';
			$countryLong = $countryLat = '';
				
			// if ip is valid do the whole thing
			if ($ipa && !$ua->isRobot()) {
				
				if (isset($_COOKIE['WIOgeoData'])) {
					// A "geoData" cookie has been previously set by the script, so we will use it
							
					// Always escape any user input, including cookies:
					list($city, $countryName, $countryAbbrev, $countryLat, $countryLong) = explode('|', strip_tags(base64_decode($_COOKIE['WIOgeoData'])));
							
				}
					
			}

			// User is logged in
			if (JAK_CLIENTID) {
				$jname = $jakclient->getVar("name");
				$_SESSION['jrc_email'] = $jakclient->getVar("email");
				$avatar = "/".JAK_FILES_DIRECTORY.$jakclient->getVar("picture");
				$_SESSION['jrc_userid'] = JAK_CLIENTID;
			// Get a random userid
			} else {
			
				// Get the avatar
				$avatar = "/package/".$jakwidget['template']."/avatar/standard.jpg";
				
				// create the guest account
				$salt = rand(100, 1000000);
				$userid = $jkl['g51'].$ipa.$salt;
				$_SESSION['jrc_name'] = ($jkp['name'] ? $jkp['name'] : filter_var($jkl['g51'].'_'.$salt, FILTER_SANITIZE_STRING));
				$_SESSION['jrc_userid'] = $userid;
				$_SESSION['jrc_email'] = ($jkp['email'] ? $jkp['email'] : "");

			}

			// Get the avatar into a session
			$_SESSION['jrc_avatar'] = $avatar;
			
			// Get the referrer
			$rowref = '';
			if (!isset($_SESSION['rlbid'])) {
			
				if (isset($_COOKIE['rlbid'])){
				   $_SESSION['rlbid'] = $_COOKIE['rlbid'];
				} else {
					$salt = rand(100, 99999);
					$rlbid = $salt.time();
					setcookie("rlbid", $rlbid, time() + 31536000, JAK_COOKIE_PATH);
					$_SESSION['rlbid'] = $rlbid;
				}
				
			} else {
				$rowref = $jakdb->get("buttonstats", "referrer", ["session" => $_SESSION['rlbid']]);
			}

			// add entry to sql
			$jakdb->insert("sessions", [ 
			"userid" => $userid,
			"clientid" => JAK_CLIENTID,
			"department" => $dep_direct,
			"operatorid" => $opdirect,
			"template" => $jakwidget['template'],
			"usr_avatar" => $avatar,
			"name" => $_SESSION['jrc_name'],
			"email" => $_SESSION['jrc_email'],
			"city" => $city,
			"country" => $countryName,
			"countrycode" => $countryAbbrev,
			"longitude" => $countryLong,
			"latitude" => $countryLat,
			"initiated" => time(),
			"status" => 1,
			"session" => $_SESSION['rlbid']]);

			$cid = $jakdb->id();
						
			if ($cid) {

				// Start with the checkstatus table
				$payfor = 0;
				foreach ($HD_DEPARTMENTS as $d) {
				    if ($dep_direct == $d["id"]) {
				        if ($d['title']) $deptitle = $d['title'];
				        if ($d['credits'] != 0) $payfor = $d['credits'];
				    }
				}

				// We have a client and a billing mode
				if (JAK_CLIENTID) {
					// Set the client chat request +1
	              	$jakdb->update("clients", ["chatrequests[+]" => 1], ["id" => JAK_CLIENTID]);
					if (JAK_BILLING_MODE == 1) {
						// Add the credits to the session so we can take it away when accepting the chat
		          		$jakdb->update("sessions", ["credits" => $payfor], ["id" => $cid]);
		          	} 
		        }

				$jakdb->insert("checkstatus", ["convid" => $cid, "depid" => $dep_direct, "department" => $deptitle, "operatorid" => $opdirect, "initiated" => time()]);
				
				$_SESSION['convid'] = $cid;

				if (!empty($HD_ANSWERS) && is_array($HD_ANSWERS)) foreach ($HD_ANSWERS as $v) {
					
					if ($v["msgtype"] == 5 && $v["lang"] == $BT_LANGUAGE) {
						
						$phold = array("%operator%","%client%","%email%");
						$replace   = array("", $_SESSION['jrc_name'], JAK_EMAIL);
						$messageaut = str_replace($phold, $replace, $v["message"]);

						$jakdb->insert("transcript", [ 
							"name" => $jkl["g56"],
							"message" => $messageaut,
							"convid" => $cid,
							"class" => "notice",
							"#time" => "NOW()"]);
							
					}
							
				}

				$jakdb->insert("transcript", [ 
					"name" => $jkl["g56"],
					"message" => $jkl['g63'],
					"convid" => $cid,
					"class" => "notice",
					"#time" => "NOW()"]);

				// Clean message
				$message = strip_tags($_POST['message']);
				$message = filter_var($message, FILTER_SANITIZE_STRING);
				$message = trim($message);

				$jakdb->insert("transcript", [ 
					"name" => $_SESSION['jrc_name'],
					"message" => $message,
					"convid" => $cid,
					"class" => "user",
					"#time" => "NOW()"]);
				
				if ($jakdb->has("user", ["AND" => ["chat_dep" => ['0', $depsql], "access" => 1, "available" => 0]])) {
				
					// Now send notifications if whish so
					$result = $jakdb->select("user", ["id", "username", "email", "emailnot", "hours_array", "pusho_tok", "pusho_key", "phonenumber", "hours_array", "push_notifications"], ["AND" => ["access" => 1, "available" => 0]]);
					
					if (isset($result) && !empty($result)) {

						foreach ($result as $row) {

							if (JAK_base::jakAvailableHours($row["hours_array"], date('Y-m-d H:i:s'))) {

								// Native App notification
								if ($row["push_notifications"] && JAK_NATIVE_APP_TOKEN && JAK_NATIVE_APP_KEY) {

									// Do we have a valid device for this user
									$vd = false;
									$vd = $jakdb->select("push_notification_devices", ["ostype", "token"], ["userid" => $row["id"]]);

									if (isset($vd) && !empty($vd)) {

										foreach ($vd as $vdrow) {

											$fields = array("token" => JAK_NATIVE_APP_TOKEN, "user" => JAK_NATIVE_APP_KEY, "ostype" => $vdrow["ostype"], "device" => $vdrow["token"], "title" => JAK_TITLE, "message" => JAK_TW_MSG);

											$str = http_build_query($fields);

											$jm = curl_init();
												curl_setopt($jm, CURLOPT_URL, "https://www.jakweb.ch/push/m");
												curl_setopt($jm, CURLOPT_HEADER, false);
												curl_setopt($jm, CURLOPT_RETURNTRANSFER, true);
												curl_setopt($jm, CURLOPT_POST, count($fields));
												curl_setopt($jm, CURLOPT_POSTFIELDS, $str);
												$response = curl_exec($jm);
												curl_close($jm);

										}
									}
								}

								// Email Notifications
								if ($row["emailnot"]) {
							
									$mail = new PHPMailer(); // defaults to using php "mail()" or optional SMTP
									
									if (JAK_SMTP_MAIL) {
									
										$mail->IsSMTP(); // telling the class to use SMTP
										$mail->Host = JAK_SMTPHOST;
										$mail->SMTPAuth = (JAK_SMTP_AUTH ? true : false); // enable SMTP authentication
										$mail->SMTPSecure = JAK_SMTP_PREFIX; // sets the prefix to the server
										$mail->SMTPAutoTLS = false;
										$mail->SMTPKeepAlive = (JAK_SMTP_ALIVE ? true : false); // SMTP connection will not close after each email sent
										$mail->Port = JAK_SMTPPORT; // set the SMTP port for the GMAIL server
										$mail->Username = JAK_SMTPUSERNAME; // SMTP account username
										$mail->Password = JAK_SMTPPASSWORD; // SMTP account password
										$mail->SetFrom($row['email']);
										$mail->AddAddress(JAK_EMAIL, JAK_TITLE);
										
									} else {
									
										$mail->SetFrom($row['email'], $row['username']);
										$mail->AddAddress(JAK_EMAIL, JAK_TITLE);
									
									}
									
									$mail->Subject = JAK_TITLE;
									$mail->MsgHTML(JAK_TW_MSG);
									$mail->Send();
									
								}

								// Pushover
								if ($row["push_notifications"] && $row["pusho_tok"] && $row["pusho_key"]) {

									$c = curl_init();
						            curl_setopt($c, CURLOPT_URL, "https://api.pushover.net/1/messages.json");
						            curl_setopt($c, CURLOPT_HEADER, false);
						            curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
						            curl_setopt($c, CURLOPT_POSTFIELDS, array(
						                "token" => $row["pusho_tok"],
		    								"user" => $row["pusho_key"],
		    								"message" => JAK_TW_MSG,
		    								"title" => JAK_TITLE,
		    								"url" => JAK_rewrite::jakParseurl(JAK_OPERATOR_LOC, 'live', $cid)
						            ));
						            $response = curl_exec($c);
						            curl_close($c);

								}

								if (JAK_TW_SID && JAK_TW_TOKEN && $row["phonenumber"]) {
								
									// Twilio
									if (JAK_TWILIO_NEXMO == 1) {
								
										$twurl = "https://api.twilio.com/2010-04-01/Accounts/".JAK_TW_SID."/Messages.json";
										$data = array (
										    'From' => JAK_TW_PHONE,
										    'To' => $row['phonenumber'],
										    'Body' => JAK_TW_MSG,
										);
										$post = http_build_query($data);
										$tw = curl_init($twurl);
										curl_setopt($tw, CURLOPT_POST, true);
										curl_setopt($tw, CURLOPT_RETURNTRANSFER, true);
										// curl_setopt($tw, CURLOPT_SSL_VERIFYPEER, false);
										curl_setopt($tw, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
										curl_setopt($tw, CURLOPT_USERPWD, JAK_TW_SID.':'.JAK_TW_TOKEN);
										curl_setopt($tw, CURLOPT_POSTFIELDS, $post);
										$twresponse = curl_exec($tw);
										curl_close($tw);
										
									// Plivo
									} elseif (JAK_TWILIO_NEXMO == 2) {

										$op_phones[] = $row['phonenumber'];
												
									// Nexmo
									} else {
										
										require_once('include/nexmo/NexmoMessage.php');
												
										// Step 1: Declare new NexmoMessage. (Api Key) (Api Secret)
										$nexmo_sms = new NexmoMessage(JAK_TW_SID, JAK_TW_TOKEN);
														
										// Step 2: Use sendText( $to, $from, $message ) method to send a message. 
										$info = $nexmo_sms->sendText($row['phonenumber'], JAK_TITLE, JAK_TW_MSG);
																				
									}
								}
					
							}
					
						}
						
						// Send the sms with plivo
						if (!empty($op_phones)) {
												
							// Join the number to a list
							$sendsmsop = join(',', $op_phones);
													
							$auth_id = JAK_TW_SID;
							$auth_token = JAK_TW_TOKEN;
							# SMS sender ID.
							$src = (JAK_TW_PHONE ? JAK_TW_PHONE : JAK_TITLE);
							# SMS destination number
							$dst = $sendsmsop;
							# SMS text
							$text = JAK_TW_MSG;
							$url = 'https://api.plivo.com/v1/Account/'.$auth_id.'/Message/';
							$data = array("src" => "$src", "dst" => "$dst", "text" => "$text");
							$data_string = json_encode($data);
							$ch = curl_init($url);
							curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
							curl_setopt($ch, CURLOPT_POST, true);
							curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
							curl_setopt($ch, CURLOPT_HEADER, true);
							curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
							curl_setopt($ch, CURLOPT_USERPWD, $auth_id . ":" . $auth_token);
							curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
							$curl_output = curl_exec($ch);
							curl_close($ch);
						}	
					}
				}
				
			}
			
			// Redirect page
			$gochat = JAK_rewrite::jakParseurl('chat', $_POST['slide_chat'], $_POST['lang'], '', '');
			
			/* Outputtng the error messages */
			if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			
				header('Cache-Control: no-cache');
				die(json_encode(array('login' => 1, 'link' => $gochat)));
				
			}
			jak_redirect($gochat);
			
		}
}

// Get the message from the proactive
$proactivemsg = '';
$proactivemsg = $jakdb->get("buttonstats", "message", ["AND" => ["session" => $_SESSION['rlbid'], "message[!]" => ""]]);

$headermsg = '';
if ($dep_direct && !empty($HD_ANSWERS) && is_array($HD_ANSWERS)) foreach ($HD_ANSWERS as $v) {
	
	if ($v["msgtype"] == 10 && $v["lang"] == $BT_LANGUAGE && $dep_direct == $v["department"]) {
	
		$phold = array("%operator%","%client%","%email%");
		$replace   = array("", "", JAK_EMAIL);
		$headermsg = str_replace($phold, $replace, $v["message"]);
		
	}
	
}

// Now we don't have a message for the department only
if (empty($headermsg)) {
	if (!empty($HD_ANSWERS) && is_array($HD_ANSWERS)) foreach ($HD_ANSWERS as $v) {
		
		if ($v["msgtype"] == 10 && $v["lang"] == $BT_LANGUAGE && $v["department"] == 0) {
		
			$phold = array("%operator%","%client%","%email%");
			$replace   = array("", "", JAK_EMAIL);
			$headermsg = str_replace($phold, $replace, $v["message"]);
			
		}
		
	}
}
?>
<!DOCTYPE html>
<html lang="<?php echo $BT_LANGUAGE;?>">
<head>
	<meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
	<meta name="author" content="Live Chat PHP">
	<title><?php echo $jkl["g"];?> - <?php echo JAK_TITLE;?></title>
	<link rel="shortcut icon" href="favicon.ico" type="image/x-icon">
	<link rel="stylesheet" href="<?php echo BASE_URL;?>css/compress.css.php" media="screen">

	<!-- Custom Styles -->
	<?php include_once('package/'.$jakwidget['template'].'/style.php');?>
	
	<!--[if lt IE 9]>
	<script src="https://html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->

	<?php if ($jkl["rtlsupport"]) { ?>
  	<!-- RTL Support -->
  	<link rel="stylesheet" href="<?php echo BASE_URL;?>css/style-rtl.css?=<?php echo JAK_UPDATED;?>" type="text/css" media="screen">
  	<!-- End RTL Support -->
  	<?php } ?>
	 
	<!-- Le fav and touch icons -->
	<link rel="shortcut icon" href="<?php echo BASE_URL;?>img/ico/favicon.ico">
<script async src="//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js"></script>
<script>
     (adsbygoogle = window.adsbygoogle || []).push({
          google_ad_client: "ca-pub-1152642518017280",
          enable_page_level_ads: true
     });
</script>	 
</head>
<body>

<?php if (isset($page1) && $page1 == 1) { include_once('package/'.$jakwidget['template'].'/slide_up/quickstart.php'); } else { include_once('package/'.$jakwidget['template'].'/pop_up/quickstart.php'); } ?>

<script type="text/javascript" src="<?php echo BASE_URL;?>js/jquery.js"></script>
<script type="text/javascript" src="<?php echo BASE_URL;?>js/functions.js"></script>
<script type="text/javascript" src="<?php echo BASE_URL;?>js/resizer.js?=<?php echo JAK_UPDATED;?>"></script>
<script type="text/javascript" src="<?php echo BASE_URL;?>js/contact.js"></script>
<script src="<?php echo BASE_URL.JAK_OPERATOR_LOC;?>/js/emoji.js" type="text/javascript"></script>
<script type="text/javascript">
	cross_url = '<?php echo (isset($_SESSION["crossurl"]) ? $_SESSION["crossurl"] : BASE_URL);?>';
	apply_animation = '<?php echo $jakwidget['chat_animation'];?>';
	<?php if (JAK_CAPTCHA) { ?>
		$(document).ready(function() {
			$(".jak-ajaxform").append('<input type="hidden" name="<?php echo $random_name;?>" value="<?php echo $random_value;?>" />');
		});
	<?php } ?>
	$(document).ready(function() {
		$("#message").fadeIn().focus();
		$('#message').keypress(function (e) {
		  if (e.which == 13) {
		    $('form.jak-ajaxform').submit();
		  }
		});
		$("#emoji").emojioneArea();
		<?php if (isset($page1) && $page1 == 1) { ?>
		iframe_resize($('#lcjframesize').width(), $('#lcjframesize').height(), "<?php echo jak_html_widget_css($jakwidget['floatpopup'], $jakwidget['floatcss'], $jakwidget['floatcsschat']);?>", cross_url);
		<?php } ?>
	});
	ls.main_url = "<?php echo BASE_URL;?>";
	ls.lsrequest_uri = "<?php echo JAK_PARSE_REQUEST;?>";
	ls.ls_submit = "<?php echo $jkl['g10'];?>";
	ls.ls_submitwait = "<?php echo $jkl['g8'];?>";
</script>
<?php if (!empty($jakgraphix["startjs"])) echo '<script type="text/javascript" src="'.BASE_URL.'package/'.$jakwidget['template'].'/'.$jakgraphix["startjs"].'"></script>';?>
</body>
</html>
<?php ob_flush(); ?>